Core Features

Advanced Features

JavaScript Data GridInfinite Row Model

Version 36.2.0

If you are an Enterprise user you should consider using the Server-Side Row Model instead of the Infinite Row Model. It offers the same functionality with many more features. The differences between row models can be found in our row models summary page.

Infinite scrolling allows the grid to lazy-load rows from the server depending on what the scroll position is of the grid. In its simplest form, the more the user scrolls down, the more rows get loaded.

The grid will have an 'auto extending' vertical scroll. That means as the scroll reaches the bottom position, the grid will extend the height to allow scrolling even further down, almost making it impossible for the user to reach the bottom. This will stop happening once the grid has extended the scroll to reach the last record in the table.

How it Works Copy Link

The grid will ask your application, via a datasource, for the rows in blocks. Each block contains a subset of rows of the entire dataset. The following diagram is a high-level overview.

high-level

When the grid scrolls to a position where there is no corresponding block of rows loaded, the model uses the provided datasource to get the rows for the requested block. In the diagram, the datasource is getting the rows from a database in a remote server.

Turning On Infinite Scrolling Copy Link

To turn on infinite scrolling, you must a) set the grid property rowModelType to 'infinite' and b) provide a datasource.

// before grid initialised
gridOptions.rowModelType = 'infinite';
gridOptions.datasource = myDataSource;

// after grid initialised, you can set or change the datasource
api.setGridOption('datasource', myDataSource);

Datasource Copy Link

A datasource must be provided to do infinite scrolling. You specify the datasource as a grid property or using the grid API.

// set as a property
gridOptions.datasource = myDatasource;

// or use the api after the grid is initialised
api.setGridOption('datasource', myDatasource);

Changing the Datasource Copy Link

Changing the datasource after the grid is initialised will reset the infinite scrolling in the grid. This is useful if the context of your data changes, i.e. if you want to look at a different set of data.

If you call setGridOption('datasource', datasource) the grid will act assuming it's a new datasource, resetting the block cache. However you can pass in the same datasource instance. So your application, for example, might have one instance of a datasource that is aware of some external context (e.g. the business date selected for a report, or the 'bank ATM instance' data you are connecting to), and when the context changes, you want to reset, but still keep the same datasource instance. In this case, just call setGridOption('datasource', datasource) and pass the same datasource in again.

Datasource Interface Copy Link

In a nutshell, every time the grid wants more rows, it will call getRows() on the datasource. The datasource responds with the rows requested. Your datasource for infinite scrolling should implement the IDatasource interface:

Properties available on the IDatasource interface.

rowCountCopy Link
number
If you know up front how many rows are in the dataset, set it here. Otherwise leave blank.
getRowsCopy Link
Function
Callback the grid calls that you implement to fetch rows from the server.
destroyCopy Link
Function
Optional destroy method, if your datasource has state it needs to clean up.

The getRows() method takes the IGetRowsParams parameters:

Properties available on the IGetRowsParams<TData = any, TContext = any> interface.

startRowCopy Link
number
The first row index to get.
endRowCopy Link
number
The first row index to NOT get.
successCallbackCopy Link
Function
Callback to call for the result when successful.
failCallbackCopy Link
Function
Callback to call when the request fails.
sortModelCopy Link
SortModelItem[]
If doing server side sorting, contains the sort model
filterModelCopy Link
any
If doing server side filtering, contains the filter model
The grid api.
Application context as set on gridOptions.context.

getRows() Copy Link

The getRows() function is called by the grid to load a block of rows into the browser-side cache of blocks. It takes the following as parameters:

  • The startRow and endRow define the range expected for the call. For example, if the getRows function is called with startRow: 0 and endRow: 100, then the grid will expect a result with 100 rows (rows 0 to 99).

  • The successCallback(rowsThisBlock, lastRow) should be called when you successfully receive data from the server. The callback has the following parameters:

    • rowsThisBlock should be the rows you have received for the current block.
    • lastRow should be the index of the last row if known.
  • The failCallback() should be called if the loading failed. Either one of successCallback() or failCallback() should be called exactly once.

  • The filterModel() and sortModel() are passed for doing server-side sorting and filtering.

  • The context is just passed as is and nothing to do with infinite scrolling. It's there if you need it for providing application state to your datasource.

Setting Last Row Index Copy Link

The success callback parameter lastRow is used to move the grid out of infinite scrolling. If the last row is known, then this should be the index of the last row. If the last row is unknown, then leave blank (undefined, null or -1). This attribute is only used when in infinite scrolling. Once the total record count is known, the lastRow parameter will be ignored.

Under normal operation, you will return null or undefined for lastRow for every time getRows() is called with the exception of when you get to the last block. For example, if block size is 100 and you have 250 rows, when getRows() is called for the third time, you will return back 50 rows in the result and set rowCount to 250. This will then get the grid to set the scrollbar to fit exactly 250 rows and will not ask for any more blocks.

Block Cache Copy Link

The grid keeps the blocks in a cache. You have the choice to never expire the blocks, or to set a limit to the number of blocks kept. If you set a limit, then as you scroll down, previous blocks will be discarded and will be loaded again if the user scrolls back up. The maximum blocks to keep in the cache is set using the maxBlocksInCache property.

Block Size Copy Link

The block size is set using the grid property cacheBlockSize. This is how many rows each block in the cache should contain. Each call to your datasource will be for one block.

Debounce Block Loading Copy Link

It is also possible to debounce the loading to prevent blocks loading until scrolling has stopped. This can be configured using: blockLoadDebounceMillis.

Aggregation and Grouping Copy Link

Aggregation and grouping are not available in infinite scrolling. This is because to do so would require the grid knowing the entire dataset, which is not possible when using the Infinite Row Model. If you need aggregation and / or grouping for large datasets, check the Server-Side Row Model for doing aggregations on the server-side.

Sorting & Filtering Copy Link

The grid cannot do sorting or filtering for you, as it does not have all of the data. Sorting or filtering must be done on the server-side. For this reason, if the sort or filter changes, the grid will use the datasource to get the data again and provide the sort and filter state to you.

Simple Example: No Sorting or Filtering Copy Link

The example below makes use of infinite scrolling and caching. Notice that the grid will load more data when you bring the scroll all the way to the bottom.

Selection Copy Link

Selection works on the rows in infinite scrolling by using the Row IDs of the Row Nodes. If you do not provide Keys for the Row Nodes, the index of the Row Node will be used. Using the index of the row breaks down when (server-side) filtering or sorting, as these change the index of the Rows. For this reason, if you do not provide your own Row IDs, then selection is cleared if sort or filter is changed.

To provide your own Row IDs, implement the method getRowId(params), which should return the Key for the data.

gridOptions.getRowId: function(params) {
    // the ID can be any string, as long as it's unique within your dataset
    return params.data.id.toString();
}

Once you have getRowId() implemented, selection will persist across sorts and filters.

The infinite row model does not have built-in support for Select-All functionality. Neither clicking the header checkbox nor pressing ^ Ctrl⌘ Command+A will have any effect.

Example: Sorting, Filtering and Selection Copy Link

The following example extends the example above by adding server-side sorting, filtering and persistent selection.

Any column can be sorted by clicking the header. When this happens, the datasource is called again with the new sort options.

The columns Age, Country and Year can be filtered. When this happens, the datasource is called again with the new filtering options.

When a row is selected, the selection will remain inside the grid, even if the grid gets sorted or filtered. Notice that when the grid loads a selected row (e.g. select first row, scroll down so the first block is removed from cache, then scroll back up again) the row is not highlighted until the row is loaded from the server. This is because the grid is waiting to see what the ID is of the row to be loaded.

The example below uses AG Grid Enterprise, to demonstrate the set filter with server-side filtering. AG Grid Enterprise is not required for infinite scrolling.

When performing multiple row selections using shift-click, it is possible that not all rows are available in memory if the configured value of maxBlocksInCache doesn't cover the range. In this case multiple selections will not be allowed.

Specify Selectable Rows Copy Link

It is also possible to specify which rows can be selected via the rowSelection.isRowSelectable callback function.

isRowSelectableCopy Link
IsRowSelectable
Callback to be used to determine which rows are selectable. By default rows are selectable, so return false to make a row non-selectable.

For instance if we only wanted to allow rows where the data.country property is the 'United States' we could implement the following:

const gridOptions = {
    rowSelection: {
        mode: 'multiRow',
        isRowSelectable: function(data) {
            return data.country === 'United States';
        }
    },

    // other grid options ...
}

Note that in the above example we have hidden disabled checkboxes to help highlight which rows are selectable.

Configuring a Bit Differently Copy Link

The examples above use old-style JavaScript objects for the datasource. This example turns things around slightly and creates a datasource Class. The example also just generates data on the fly.

Loading Spinner Copy Link

The examples on this page use a loading spinner to show if the row is waiting for its data to be loaded. The grid does not provide this, rather it is a simple rendering technique used in the examples. If the data is loading, then the rowNode will have no ID, so if you use the ID as the value, the cell will get refreshed when the ID is set.

loadingSpinnerColumn = {
    // use a value getter to have the node ID as this column's value
    valueGetter: 'node.id',

    // then a custom cellRenderer
    cellRenderer: function(params) {
        if (params.value === undefined) {
            // when no node id, display the spinner image
            return '<img src="loading.gif" />';
        } else {
            // otherwise just display node ID (or whatever you wish for this column)
            return params.value;
        }
    }
}

Refer to section Cell Rendering for how to build cell renderers.

More Control via Properties and API Copy Link

Infinite scrolling has a cache working behind the scenes. The following properties and API are provided to give you control of the cache.

Properties Copy Link

cacheOverflowSizeCopy Link
number
default: 1
How many extra blank rows to display to the user at the end of the dataset, which sets the vertical scroll and then allows the grid to request viewing more rows of data.
maxConcurrentDatasourceRequestsCopy Link
number
default: 2
How many requests to hit the server with concurrently. If the max is reached, requests are queued. Set to -1 for no maximum restriction on requests.
cacheBlockSizeCopy Link
number
default: 100
How many rows for each block in the store, i.e. how many rows returned from the server at a time.
maxBlocksInCacheCopy Link
number
How many blocks to keep in the store. Default is no limit, so every requested block is kept. Use this if you have memory concerns, and blocks that were least recently viewed will be purged when the limit is hit. The grid will additionally make sure it has all the blocks needed to display what is currently visible, in case this property is set to a low value.
infiniteInitialRowCountCopy Link
number
default: 1
How many extra blank rows to display to the user at the end of the dataset, which sets the vertical scroll and then allows the grid to request viewing more rows of data.

API Copy Link

refreshInfiniteCacheCopy Link
Function
Marks all the currently loaded blocks in the cache for reload. If you have 10 blocks in the cache, all 10 will be marked for reload. The old data will continue to be displayed until the new data is loaded.
purgeInfiniteCacheCopy Link
Function
Purges the cache. The grid is then told to refresh. Only the blocks required to display the current data on screen are fetched (typically no more than 2). The grid will display nothing while the new blocks are loaded. Use this to immediately remove the old data from the user.
isLastRowIndexKnownCopy Link
Function
Returns false if grid allows for scrolling past the last row to load more rows, thus providing infinite scroll.
setRowCountCopy Link
Function
Sets the rowCount and maxRowFound properties. The second parameter, maxRowFound, is optional and if left out, only rowCount is set. Set rowCount to adjust the height of the vertical scroll. Set maxRowFound to enable / disable searching for more rows. Use this method if you add or remove rows into the dataset and need to reset the number of rows or instruct the grid that the entire row count is no longer known.
getCacheBlockStateCopy Link
Function
Returns an object representing the state of the cache. This is useful for debugging and understanding how the cache is working.

Adding / removing rows directly in the grid for infinite scrolling is not recommended as it will complicate your application. It will make your life easier if you update the data on the server and refresh the block cache.

Example: Using Cache API Methods Copy Link

Below demonstrates the different API methods via the buttons. The example outputs a lot of debugging items to the console because the grid property debug=true is set. The buttons are as follows:

  • Insert Rows: Inserts 5 rows at row index 2 from the server, then refreshes the grid.
  • Delete Rows: Deletes 10 rows at row index 3 from the server, then refreshes the grid.
  • Set Row Count: Sets the row count to 200. This adjusts the vertical scroll to show 200 rows. If the scroll is positioned at the end, this results in the grid automatically re-adjusting as it seeks ahead for the next block of data.
  • Print Info: Prints rowCount and maxFound to the console.
  • Jump to 500: Positions the grid so that row 500 is displayed.
  • Print Cache State: Debugging method, to see the state of the cache.
  • Set Prices High & Set Prices Low: Sets the prices on the server-side to either high or low prices. This will not impact the grid until after a block cache is loaded. Use these buttons to then further test the refresh and purge methods.
  • Refresh Cache: Calls for the cache to be refreshed.
  • Purge Cache: Calls for the cache to be purged.

The example also makes each Honda row bold - demonstrating that the callbacks getRowStyle and getRowClass get called after the data is set as well as when the row is created (when the data may not yet be available).

Changing Columns Copy Link

Changing columns is possible using infinite scroll and it does not require the data getting fetched again from the server. If the change of columns impacts the sort or filter (i.e. a column with a sort or filter applied is removed), the grid will fetch data again similar to how data is fetched again after the user changes the sort or filter explicitly.

The example below demonstrates changing columns on the infinite row model. The following can be noted:

  • Hit the buttons 'Show Year' and 'Hide Year'. Notice that the data is not re-fetched.
  • Add a sort or filter to Age column. When the sort or filter is applied the data is re-fetched. However once fetched, you can add and remove the Year column without re-fetching the data.
  • Add a sort or filter to the Year column. When the sort or filter is applied the data is re-fetched. Now remove the Year column and the data is re-fetched again as the sort or filter has changed.

Pagination Copy Link

As with all row models, it is possible to enable pagination with infinite scrolling. With infinite scrolling, it is possible to mix and match with the configuration to achieve different effects. The following examples are presented:

ExamplePage SizeBlock SizeComment
Example 1AutoLargeMost Recommended
Example 2EqualEqualRecommended Sometimes

Having smaller infinite blocks size than your pagination page size is not supported

You must have infinite block size greater than or equal to the pagination page size. If you have a smaller block size, the grid will not fetch enough rows to display one page. This breaks how infinite scrolling works and is not supported.

Example 1: Auto Pagination Page Size, Large Infinite Block Size Copy Link

This example is the recommended approach. The infinite block size is larger than the pages size, so the grid loads data for a few pages, allowing the user to hit 'next' a few times before a server sided call is needed.

Example 2: Equal Pagination Page Size and Large Infinite Block Size Copy Link

This example demonstrates having the page and block sizes equal. Here the server is hit every time a new page is navigated to.

Overlays Copy Link

The infinite row model does not automatically show the loading overlay as rows are loaded in blocks as the user interacts with the grid. The grid will show the no rows overlay if the datasource returns an empty array and the no matching rows overlay if an empty array is returned while filters are set.

For configuration details, including suppressing the built in overlays, see Overlays.

If you are an Enterprise user you should consider using the Server-Side Row Model instead of the Infinite Row Model. It offers the same functionality with many more features. The differences between row models can be found in our row models summary page.
Infinite scrolling allows the grid to lazy-load rows from the server depending on what the scroll position is of the grid. In its simplest form, the more the user scrolls down, the more rows get loaded.
The grid will have an 'auto extending' vertical scroll. That means as the scroll reaches the bottom position, the grid will extend the height to allow scrolling even further down, almost making it impossible for the user to reach the bottom. This will stop happening once the grid has extended the scroll to reach the last record in the table.
How it Works Copy Link
The grid will ask your application, via a datasource, for the rows in blocks. Each block contains a subset of rows of the entire dataset. The following diagram is a high-level overview.
When the grid scrolls to a position where there is no corresponding block of rows loaded, the model uses the provided datasource to get the rows for the requested block. In the diagram, the datasource is getting the rows from a database in a remote server.
Turning On Infinite Scrolling Copy Link
To turn on infinite scrolling, you must a) set the grid property rowModelType to 'infinite' and b) provide a datasource.
// before grid initialised
gridOptions.rowModelType = 'infinite';
gridOptions.datasource = myDataSource;
// after grid initialised, you can set or change the datasource
api.setGridOption('datasource', myDataSource); Datasource Copy Link
A datasource must be provided to do infinite scrolling. You specify the datasource as a grid property or using the grid API.
// set as a property
gridOptions.datasource = myDatasource;
// or use the api after the grid is initialised
api.setGridOption('datasource', myDatasource); Changing the Datasource Copy Link
Changing the datasource after the grid is initialised will reset the infinite scrolling in the grid. This is useful if the context of your data changes, i.e. if you want to look at a different set of data.
If you call setGridOption('datasource', datasource) the grid will act assuming it's a new datasource, resetting the block cache. However you can pass in the same datasource instance. So your application, for example, might have one instance of a datasource that is aware of some external context (e.g. the business date selected for a report, or the 'bank ATM instance' data you are connecting to), and when the context changes, you want to reset, but still keep the same datasource instance. In this case, just call setGridOption('datasource', datasource) and pass the same datasource in again.
Datasource Interface Copy Link
In a nutshell, every time the grid wants more rows, it will call getRows() on the datasource. The datasource responds with the rows requested. Your datasource for infinite scrolling should implement the IDatasource interface:
Properties available on the IDatasource interface.
If you know up front how many rows are in the dataset, set it here. Otherwise leave blank. |
Callback the grid calls that you implement to fetch rows from the server. |
Optional destroy method, if your datasource has state it needs to clean up. |
The getRows() method takes the IGetRowsParams parameters:
Properties available on the IGetRowsParams<TData = any, TContext = any> interface.
The first row index to get. |
The first row index to NOT get. |
Callback to call for the result when successful. |
Callback to call when the request fails. |
If doing server side sorting, contains the sort model |
If doing server side filtering, contains the filter model |
The grid api. |
Application context as set on gridOptions.context. |
getRows() Copy Link
The getRows() function is called by the grid to load a block of rows into the browser-side cache of blocks. It takes the following as parameters:
The
startRowandendRowdefine the range expected for the call. For example, if thegetRowsfunction is called withstartRow: 0andendRow: 100, then the grid will expect a result with 100 rows (rows 0 to 99).The
successCallback(rowsThisBlock, lastRow)should be called when you successfully receive data from the server. The callback has the following parameters:rowsThisBlockshould be the rows you have received for the current block.lastRowshould be the index of the last row if known.
The
failCallback()should be called if the loading failed. Either one ofsuccessCallback()orfailCallback()should be called exactly once.The
filterModel()andsortModel()are passed for doing server-side sorting and filtering.The context is just passed as is and nothing to do with infinite scrolling. It's there if you need it for providing application state to your datasource.
Setting Last Row Index Copy Link
The success callback parameter lastRow is used to move the grid out of infinite scrolling. If the last row is known, then this should be the index of the last row. If the last row is unknown, then leave blank (undefined, null or -1). This attribute is only used when in infinite scrolling. Once the total record count is known, the lastRow parameter will be ignored.
Under normal operation, you will return null or undefined for lastRow for every time getRows() is called with the exception of when you get to the last block. For example, if block size is 100 and you have 250 rows, when getRows() is called for the third time, you will return back 50 rows in the result and set rowCount to 250. This will then get the grid to set the scrollbar to fit exactly 250 rows and will not ask for any more blocks.
Block Cache Copy Link
The grid keeps the blocks in a cache. You have the choice to never expire the blocks, or to set a limit to the number of blocks kept. If you set a limit, then as you scroll down, previous blocks will be discarded and will be loaded again if the user scrolls back up. The maximum blocks to keep in the cache is set using the maxBlocksInCache property.
Block Size Copy Link
The block size is set using the grid property cacheBlockSize. This is how many rows each block in the cache should contain. Each call to your datasource will be for one block.
Debounce Block Loading Copy Link
It is also possible to debounce the loading to prevent blocks loading until scrolling has stopped. This can be configured using: blockLoadDebounceMillis.
Aggregation and Grouping Copy Link
Aggregation and grouping are not available in infinite scrolling. This is because to do so would require the grid knowing the entire dataset, which is not possible when using the Infinite Row Model. If you need aggregation and / or grouping for large datasets, check the Server-Side Row Model for doing aggregations on the server-side.
Sorting & Filtering Copy Link
The grid cannot do sorting or filtering for you, as it does not have all of the data. Sorting or filtering must be done on the server-side. For this reason, if the sort or filter changes, the grid will use the datasource to get the data again and provide the sort and filter state to you.
Simple Example: No Sorting or Filtering Copy Link
The example below makes use of infinite scrolling and caching. Notice that the grid will load more data when you bring the scroll all the way to the bottom.
'use client';
import React, { StrictMode, useCallback, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";
import type { ColDef, GridReadyEvent, IDatasource } from "ag-grid-community";
import {
InfiniteRowModelModule,
enableDevValidations,
} from "ag-grid-community";
import type { CustomCellRendererProps } from "ag-grid-react";
import { AgGridProvider, AgGridReact } from "ag-grid-react";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [InfiniteRowModelModule];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
// this row shows the row index, doesn't use any data from the row
{
headerName: "ID",
maxWidth: 100,
// it is important to have node.id here, so that when the id changes (which happens
// when the row is loaded) then the cell is refreshed.
valueGetter: "node.id",
cellRenderer: (props: CustomCellRendererProps) => {
if (props.value !== undefined) {
return props.value;
} else {
return (
<img src="https://www.ag-grid.com/example-assets/loading.gif" />
);
}
},
},
{ field: "athlete", minWidth: 150 },
{ field: "age" },
{ field: "country", minWidth: 150 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 100,
sortable: false,
};
}, []);
const onGridReady = useCallback((params: GridReadyEvent) => {
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => {
const dataSource: IDatasource = {
rowCount: undefined,
getRows: (params) => {
console.log(
"asking for " + params.startRow + " to " + params.endRow,
);
// At this point in your code, you would call the server.
// To make the demo look real, wait for 500ms before returning
setTimeout(function () {
// take a slice of the total rows
const rowsThisPage = data.slice(params.startRow, params.endRow);
// if on or after the last page, work out the last row.
let lastRow = -1;
if (data.length <= params.endRow) {
lastRow = data.length;
}
// call the success callback
params.successCallback(rowsThisPage, lastRow);
}, 500);
},
};
params.api.setGridOption("datasource", dataSource);
});
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact
columnDefs={columnDefs}
defaultColDef={defaultColDef}
rowBuffer={0}
rowModelType={"infinite"}
cacheBlockSize={100}
cacheOverflowSize={2}
maxConcurrentDatasourceRequests={1}
infiniteInitialRowCount={1000}
maxBlocksInCache={10}
onGridReady={onGridReady}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Selection Copy Link
Selection works on the rows in infinite scrolling by using the Row IDs of the Row Nodes. If you do not provide Keys for the Row Nodes, the index of the Row Node will be used. Using the index of the row breaks down when (server-side) filtering or sorting, as these change the index of the Rows. For this reason, if you do not provide your own Row IDs, then selection is cleared if sort or filter is changed.
To provide your own Row IDs, implement the method getRowId(params), which should return the Key for the data.
gridOptions.getRowId: function(params) {
// the ID can be any string, as long as it's unique within your dataset
return params.data.id.toString();
}Once you have getRowId() implemented, selection will persist across sorts and filters.
The infinite row model does not have built-in support for Select-All functionality. Neither clicking the header checkbox nor pressing ^ Ctrl⌘ Command+A will have any effect.
Example: Sorting, Filtering and Selection Copy Link
The following example extends the example above by adding server-side sorting, filtering and persistent selection.
Any column can be sorted by clicking the header. When this happens, the datasource is called again with the new sort options.
The columns Age, Country and Year can be filtered. When this happens, the datasource is called again with the new filtering options.
When a row is selected, the selection will remain inside the grid, even if the grid gets sorted or filtered. Notice that when the grid loads a selected row (e.g. select first row, scroll down so the first block is removed from cache, then scroll back up again) the row is not highlighted until the row is loaded from the server. This is because the grid is waiting to see what the ID is of the row to be loaded.
The example below uses AG Grid Enterprise, to demonstrate the set filter with server-side filtering. AG Grid Enterprise is not required for infinite scrolling.
'use client';
import React, { StrictMode, useCallback, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";
import type {
ColDef,
GetRowIdParams,
GridReadyEvent,
IDatasource,
RowSelectionOptions,
} from "ag-grid-community";
import {
InfiniteRowModelModule,
NumberFilterModule,
RowSelectionModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
SetFilterModule,
} from "ag-grid-enterprise";
import type { CustomCellRendererProps } from "ag-grid-react";
import { AgGridProvider, AgGridReact } from "ag-grid-react";
import { getCountries } from "./countries";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
NumberFilterModule,
RowSelectionModule,
InfiniteRowModelModule,
SetFilterModule,
ColumnMenuModule,
ContextMenuModule,
ColumnsToolPanelModule,
];
const filterParams = { values: getCountries() };
const sortAndFilter = (
allOfTheData: any[],
sortModel: any,
filterModel: any,
) => {
return sortData(sortModel, filterData(filterModel, allOfTheData));
};
const sortData = (sortModel: any, data: any[]) => {
const sortPresent = sortModel && sortModel.length > 0;
if (!sortPresent) {
return data;
}
// do an in memory sort of the data, across all the fields
const resultOfSort = data.slice();
resultOfSort.sort(function (a, b) {
for (let k = 0; k < sortModel.length; k++) {
const sortColModel = sortModel[k];
const valueA = a[sortColModel.colId];
const valueB = b[sortColModel.colId];
// this filter didn't find a difference, move onto the next one
if (valueA == valueB) {
continue;
}
const sortDirection = sortColModel.sort === "asc" ? 1 : -1;
if (valueA > valueB) {
return sortDirection;
} else {
return sortDirection * -1;
}
}
// no filters found a difference
return 0;
});
return resultOfSort;
};
const filterData = (filterModel: any, data: any[]) => {
const filterPresent = filterModel && Object.keys(filterModel).length > 0;
if (!filterPresent) {
return data;
}
const resultOfFilter = [];
for (let i = 0; i < data.length; i++) {
const item = data[i];
if (filterModel.age) {
const age = item.age;
const allowedAge = parseInt(filterModel.age.filter);
// EQUALS = 1;
// LESS_THAN = 2;
// GREATER_THAN = 3;
if (filterModel.age.type == "equals") {
if (age !== allowedAge) {
continue;
}
} else if (filterModel.age.type == "lessThan") {
if (age >= allowedAge) {
continue;
}
} else {
if (age <= allowedAge) {
continue;
}
}
}
if (filterModel.year) {
if (filterModel.year.values.indexOf(item.year.toString()) < 0) {
// year didn't match, so skip this record
continue;
}
}
if (filterModel.country) {
if (filterModel.country.values.indexOf(item.country) < 0) {
continue;
}
}
resultOfFilter.push(item);
}
return resultOfFilter;
};
const rowSelection: RowSelectionOptions = {
mode: "multiRow",
headerCheckbox: false,
};
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
// this row just shows the row index, doesn't use any data from the row
{
headerName: "ID",
maxWidth: 100,
valueGetter: "node.id",
cellRenderer: (props: CustomCellRendererProps) => {
if (props.value !== undefined) {
return props.value;
} else {
return (
<img src="https://www.ag-grid.com/example-assets/loading.gif" />
);
}
},
// we don't want to sort by the row index, this doesn't make sense as the point
// of the row index is to know the row index in what came back from the server
sortable: false,
suppressHeaderMenuButton: true,
},
{ field: "athlete", suppressHeaderMenuButton: true },
{
field: "age",
filter: "agNumberColumnFilter",
filterParams: {
filterOptions: ["equals", "lessThan", "greaterThan"],
maxNumConditions: 1,
},
},
{
field: "country",
filter: "agSetColumnFilter",
filterParams: filterParams,
},
{
field: "year",
filter: "agSetColumnFilter",
filterParams: { values: ["2000", "2004", "2008", "2012"] },
},
{ field: "date" },
{ field: "sport", suppressHeaderMenuButton: true },
{ field: "gold", suppressHeaderMenuButton: true },
{ field: "silver", suppressHeaderMenuButton: true },
{ field: "bronze", suppressHeaderMenuButton: true },
{ field: "total", suppressHeaderMenuButton: true },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 150,
floatingFilter: true,
};
}, []);
const getRowId = useCallback(function (params: GetRowIdParams) {
return params.data.id;
}, []);
const onGridReady = useCallback((params: GridReadyEvent) => {
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data: any[]) => {
// give each row an id
data.forEach(function (d, index) {
d.id = "R" + (index + 1);
});
const dataSource: IDatasource = {
rowCount: undefined,
getRows: (params) => {
console.log(
"asking for " + params.startRow + " to " + params.endRow,
);
// At this point in your code, you would call the server.
// To make the demo look real, wait for 500ms before returning
setTimeout(function () {
// take a slice of the total rows
const dataAfterSortingAndFiltering = sortAndFilter(
data,
params.sortModel,
params.filterModel,
);
const rowsThisPage = dataAfterSortingAndFiltering.slice(
params.startRow,
params.endRow,
);
// if on or after the last page, work out the last row.
let lastRow = -1;
if (dataAfterSortingAndFiltering.length <= params.endRow) {
lastRow = dataAfterSortingAndFiltering.length;
}
// call the success callback
params.successCallback(rowsThisPage, lastRow);
}, 500);
},
};
params.api.setGridOption("datasource", dataSource);
});
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact
columnDefs={columnDefs}
defaultColDef={defaultColDef}
rowSelection={rowSelection}
rowModelType={"infinite"}
cacheBlockSize={100}
cacheOverflowSize={2}
maxConcurrentDatasourceRequests={2}
infiniteInitialRowCount={1}
maxBlocksInCache={2}
getRowId={getRowId}
onGridReady={onGridReady}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export function getCountries() {
return [
"United States",
"Russia",
"Australia",
"Canada",
"Norway",
"China",
"Zimbabwe",
"Netherlands",
"South Korea",
"Croatia",
"France",
"Japan",
"Hungary",
"Germany",
"Poland",
"South Africa",
"Sweden",
"Ukraine",
"Italy",
"Czech Republic",
"Austria",
"Finland",
"Romania",
"Great Britain",
"Jamaica",
"Singapore",
"Belarus",
"Chile",
"Spain",
"Tunisia",
"Brazil",
"Slovakia",
"Costa Rica",
"Bulgaria",
"Switzerland",
"New Zealand",
"Estonia",
"Kenya",
"Ethiopia",
"Trinidad and Tobago",
"Turkey",
"Morocco",
"Bahamas",
"Slovenia",
"Armenia",
"Azerbaijan",
"India",
"Puerto Rico",
"Egypt",
"Kazakhstan",
"Iran",
"Georgia",
"Lithuania",
"Cuba",
"Colombia",
"Mongolia",
"Uzbekistan",
"North Korea",
"Tajikistan",
"Kyrgyzstan",
"Greece",
"Macedonia",
"Moldova",
"Chinese Taipei",
"Indonesia",
"Thailand",
"Vietnam",
"Latvia",
"Venezuela",
"Mexico",
"Nigeria",
"Qatar",
"Serbia",
"Serbia and Montenegro",
"Hong Kong",
"Denmark",
"Portugal",
"Argentina",
"Afghanistan",
"Gabon",
"Dominican Republic",
"Belgium",
"Kuwait",
"United Arab Emirates",
"Cyprus",
"Israel",
"Algeria",
"Montenegro",
"Iceland",
"Paraguay",
"Cameroon",
"Saudi Arabia",
"Ireland",
"Malaysia",
"Uruguay",
"Togo",
"Mauritius",
"Syria",
"Botswana",
"Guatemala",
"Bahrain",
"Grenada",
"Uganda",
"Sudan",
"Ecuador",
"Panama",
"Eritrea",
"Sri Lanka",
"Mozambique",
"Barbados",
];
}
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} When performing multiple row selections using shift-click, it is possible that not all rows are available in memory if the configured value of maxBlocksInCache doesn't cover the range. In this case multiple selections will not be allowed.
Specify Selectable Rows Copy Link
It is also possible to specify which rows can be selected via the rowSelection.isRowSelectable callback function.
Callback to be used to determine which rows are selectable. By default rows are selectable, so return false to make a row non-selectable.
|
For instance if we only wanted to allow rows where the data.country property is the 'United States' we could implement the following:
const rowSelection = useMemo(() => {
return {
mode: 'multiRow',
isRowSelectable: function(data) {
return data.country === 'United States';
}
};
}, []);
<AgGridReact rowSelection={rowSelection} />'use client';
import React, { StrictMode, useCallback, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";
import type {
ColDef,
GridReadyEvent,
IDatasource,
IRowNode,
RowSelectionOptions,
} from "ag-grid-community";
import {
InfiniteRowModelModule,
RowSelectionModule,
enableDevValidations,
} from "ag-grid-community";
import type { CustomCellRendererProps } from "ag-grid-react";
import { AgGridProvider, AgGridReact } from "ag-grid-react";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [RowSelectionModule, InfiniteRowModelModule];
const rowSelection: RowSelectionOptions = {
mode: "multiRow",
hideDisabledCheckboxes: true,
headerCheckbox: false,
isRowSelectable: (rowNode: IRowNode) => {
return rowNode.data ? rowNode.data.country === "United States" : false;
},
};
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
// this row shows the row index, doesn't use any data from the row
{
headerName: "ID",
maxWidth: 100,
// it is important to have node.id here, so that when the id changes (which happens
// when the row is loaded) then the cell is refreshed.
valueGetter: "node.id",
cellRenderer: (props: CustomCellRendererProps) => {
if (props.value !== undefined) {
return props.value;
} else {
return (
<img src="https://www.ag-grid.com/example-assets/loading.gif" />
);
}
},
},
{ field: "athlete", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 200 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 100,
sortable: false,
};
}, []);
const onGridReady = useCallback((params: GridReadyEvent) => {
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => {
const dataSource: IDatasource = {
rowCount: undefined,
getRows: (params) => {
// console.log('asking for ' + params.startRow + ' to ' + params.endRow);
// At this point in your code, you would call the server.
// To make the demo look real, wait for 500ms before returning
setTimeout(function () {
// take a slice of the total rows
const rowsThisPage = data.slice(params.startRow, params.endRow);
// if on or after the last page, work out the last row.
let lastRow = -1;
if (data.length <= params.endRow) {
lastRow = data.length;
}
// call the success callback
params.successCallback(rowsThisPage, lastRow);
}, 500);
},
};
params.api.setGridOption("datasource", dataSource);
});
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact
columnDefs={columnDefs}
defaultColDef={defaultColDef}
rowBuffer={0}
rowSelection={rowSelection}
rowModelType={"infinite"}
cacheBlockSize={100}
cacheOverflowSize={2}
maxConcurrentDatasourceRequests={2}
infiniteInitialRowCount={1}
maxBlocksInCache={2}
onGridReady={onGridReady}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Note that in the above example we have hidden disabled checkboxes to help highlight which rows are selectable.
Configuring a Bit Differently Copy Link
The examples above use old-style JavaScript objects for the datasource. This example turns things around slightly and creates a datasource Class. The example also just generates data on the fly.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
ColDef,
ColGroupDef,
ColumnApiModule,
GetRowIdFunc,
GetRowIdParams,
GridApi,
GridOptions,
IDatasource,
IGetRowsParams,
InfiniteRowModelModule,
ModuleRegistry,
RowModelType,
RowSelectionModule,
RowSelectionOptions,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [ColumnApiModule, RowSelectionModule, InfiniteRowModelModule];
const ALPHABET = "abcdefghijklmnopqrstuvwxyz".split("");
function getColumnDefs() {
const columnDefs: ColDef[] = [
{ headerName: "#", width: 80, valueGetter: "node.rowIndex" },
];
ALPHABET.forEach((letter) => {
columnDefs.push({
headerName: letter.toUpperCase(),
field: letter,
width: 150,
});
});
return columnDefs;
}
function getDataSource(count: number) {
const dataSource: IDatasource = {
rowCount: count,
getRows: (params: IGetRowsParams) => {
const rowsThisPage: any[] = [];
for (
var rowIndex = params.startRow;
rowIndex < params.endRow;
rowIndex++
) {
var record: Record<string, string> = {};
ALPHABET.forEach(function (letter, colIndex) {
const randomNumber = 17 + rowIndex + colIndex;
const cellKey = letter.toUpperCase() + (rowIndex + 1);
record[letter] = cellKey + " = " + randomNumber;
});
rowsThisPage.push(record);
}
// to mimic server call, we reply after a short delay
setTimeout(() => {
// no need to pass the second 'rowCount' parameter as we have already provided it
params.successCallback(rowsThisPage);
}, 100);
},
};
return dataSource;
}
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>(getColumnDefs());
const rowSelection = useMemo<
RowSelectionOptions | "single" | "multiple"
>(() => {
return { mode: "multiRow", headerCheckbox: false };
}, []);
const getRowId = useCallback((params: GetRowIdParams) => {
return params.data.a;
}, []);
const datasource = useMemo<IDatasource>(() => {
return getDataSource(100);
}, []);
const defaultColDef = useMemo<ColDef>(() => {
return {
sortable: false,
};
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact
columnDefs={columnDefs}
rowModelType={"infinite"}
rowSelection={rowSelection}
maxBlocksInCache={2}
getRowId={getRowId}
datasource={datasource}
defaultColDef={defaultColDef}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
Loading Spinner Copy Link
The examples on this page use a loading spinner to show if the row is waiting for its data to be loaded. The grid does not provide this, rather it is a simple rendering technique used in the examples. If the data is loading, then the rowNode will have no ID, so if you use the ID as the value, the cell will get refreshed when the ID is set.
loadingSpinnerColumn = {
// use a value getter to have the node ID as this column's value
valueGetter: 'node.id',
// then a custom cellRenderer
cellRenderer: function(params) {
if (params.value === undefined) {
// when no node id, display the spinner image
return '<img src="loading.gif" />';
} else {
// otherwise just display node ID (or whatever you wish for this column)
return params.value;
}
}
}Refer to section Cell Rendering for how to build cell renderers.
More Control via Properties and API Copy Link
Infinite scrolling has a cache working behind the scenes. The following properties and API are provided to give you control of the cache.
Properties Copy Link
How many extra blank rows to display to the user at the end of the dataset, which sets the vertical scroll and then allows the grid to request viewing more rows of data. |
How many requests to hit the server with concurrently. If the max is reached, requests are queued.
Set to -1 for no maximum restriction on requests. |
How many rows for each block in the store, i.e. how many rows returned from the server at a time. |
How many blocks to keep in the store. Default is no limit, so every requested block is kept. Use this if you have memory concerns, and blocks that were least recently viewed will be purged when the limit is hit. The grid will additionally make sure it has all the blocks needed to display what is currently visible, in case this property is set to a low value. |
How many extra blank rows to display to the user at the end of the dataset, which sets the vertical scroll and then allows the grid to request viewing more rows of data. |
API Copy Link
Marks all the currently loaded blocks in the cache for reload.
If you have 10 blocks in the cache, all 10 will be marked for reload.
The old data will continue to be displayed until the new data is loaded. |
Purges the cache.
The grid is then told to refresh. Only the blocks required to display the current data on screen are fetched (typically no more than 2).
The grid will display nothing while the new blocks are loaded.
Use this to immediately remove the old data from the user. |
Returns false if grid allows for scrolling past the last row to load more rows, thus providing infinite scroll. |
Sets the rowCount and maxRowFound properties.
The second parameter, maxRowFound, is optional and if left out, only rowCount is set.
Set rowCount to adjust the height of the vertical scroll.
Set maxRowFound to enable / disable searching for more rows.
Use this method if you add or remove rows into the dataset and need to reset the number of rows or instruct the grid that the entire row count is no longer known. |
Returns an object representing the state of the cache. This is useful for debugging and understanding how the cache is working. |
Adding / removing rows directly in the grid for infinite scrolling is not recommended as it will complicate your application. It will make your life easier if you update the data on the server and refresh the block cache.
Example: Using Cache API Methods Copy Link
Below demonstrates the different API methods via the buttons. The example outputs a lot of debugging items to the console because the grid property debug=true is set. The buttons are as follows:
- Insert Rows: Inserts 5 rows at row index 2 from the server, then refreshes the grid.
- Delete Rows: Deletes 10 rows at row index 3 from the server, then refreshes the grid.
- Set Row Count: Sets the row count to 200. This adjusts the vertical scroll to show 200 rows. If the scroll is positioned at the end, this results in the grid automatically re-adjusting as it seeks ahead for the next block of data.
- Print Info: Prints
rowCountandmaxFoundto the console. - Jump to 500: Positions the grid so that row 500 is displayed.
- Print Cache State: Debugging method, to see the state of the cache.
- Set Prices High & Set Prices Low: Sets the prices on the server-side to either high or low prices. This will not impact the grid until after a block cache is loaded. Use these buttons to then further test the refresh and purge methods.
- Refresh Cache: Calls for the cache to be refreshed.
- Purge Cache: Calls for the cache to be purged.
The example also makes each Honda row bold - demonstrating that the callbacks getRowStyle and getRowClass get called after the data is set as well as when the row is created (when the data may not yet be available).
'use client';
import React, {
StrictMode,
useCallback,
useMemo,
useRef,
useState,
} from "react";
import { createRoot } from "react-dom/client";
import type {
ColDef,
GetRowIdParams,
GridReadyEvent,
IDatasource,
RowClassParams,
ValueFormatterParams,
} from "ag-grid-community";
import {
InfiniteRowModelModule,
RowApiModule,
RowStyleModule,
ScrollApiModule,
enableDevValidations,
} from "ag-grid-community";
import type { CustomCellRendererProps } from "ag-grid-react";
import { AgGridProvider, AgGridReact } from "ag-grid-react";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
RowApiModule,
ScrollApiModule,
RowStyleModule,
InfiniteRowModelModule,
];
const valueFormatter = function (params: ValueFormatterParams) {
if (typeof params.value === "number") {
return "£" + params.value.toLocaleString();
} else {
return params.value;
}
};
// this counter is used to give id's to the rows
let sequenceId = 0;
let allOfTheData: any[] = [];
const createRowData = (id: number) => {
const makes = ["Toyota", "Ford", "Porsche", "Chevy", "Honda", "Nissan"];
const models = [
"Cruze",
"Celica",
"Mondeo",
"Boxster",
"Genesis",
"Accord",
"Taurus",
];
return {
id: id,
make: makes[id % makes.length],
model: models[id % models.length],
price: 72000,
};
};
const insertItemsAt2 = (count: number) => {
const newDataItems = [];
for (let i = 0; i < count; i++) {
const newItem = createRowData(sequenceId++);
allOfTheData.splice(2, 0, newItem);
newDataItems.push(newItem);
}
return newDataItems;
};
const GridExample = () => {
const gridRef = useRef<AgGridReact>(null);
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{
headerName: "Item ID",
field: "id",
valueGetter: "node.id",
cellRenderer: (props: CustomCellRendererProps) => {
if (props.value !== undefined) {
return props.value;
} else {
return (
<img src="https://www.ag-grid.com/example-assets/loading.gif" />
);
}
},
},
{ field: "make" },
{ field: "model" },
{
field: "price",
valueFormatter: valueFormatter,
},
]);
const datasource = useMemo<IDatasource>(() => {
return {
rowCount: undefined,
getRows: (params) => {
console.log("asking for " + params.startRow + " to " + params.endRow);
// At this point in your code, you would call the server.
// To make the demo look real, wait for 500ms before returning
setTimeout(function () {
// take a slice of the total rows
const rowsThisPage = allOfTheData.slice(
params.startRow,
params.endRow,
);
// make a copy of each row - this is what would happen if taking data from server
for (let i = 0; i < rowsThisPage.length; i++) {
const item = rowsThisPage[i];
// this is a trick to copy an object
const itemCopy = JSON.parse(JSON.stringify(item));
rowsThisPage[i] = itemCopy;
}
// if on or after the last page, work out the last row.
let lastRow = -1;
if (allOfTheData.length <= params.endRow) {
lastRow = allOfTheData.length;
}
// call the success callback
params.successCallback(rowsThisPage, lastRow);
}, 500);
},
};
}, []);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
sortable: false,
};
}, []);
const getRowId = useCallback(function (params: GetRowIdParams) {
return params.data.id.toString();
}, []);
const getRowStyle = useCallback(function (params: RowClassParams) {
if (params.data && params.data.make === "Honda") {
return {
fontWeight: "bold",
};
}
return {
fontWeight: "normal",
};
}, []);
const onGridReady = useCallback((params: GridReadyEvent) => {
sequenceId = 1;
allOfTheData = [];
for (let i = 0; i < 1000; i++) {
allOfTheData.push(createRowData(sequenceId++));
}
}, []);
const insertItemsAt2AndRefresh = useCallback((count: number) => {
insertItemsAt2(count);
// if the data has stopped looking for the last row, then we need to adjust the
// row count to allow for the extra data, otherwise the grid will not allow scrolling
// to the last row. eg if we have 1000 rows, scroll all the way to the bottom (so
// maxRowFound=true), and then add 5 rows, the rowCount needs to be adjusted
// to 1005, so grid can scroll to the end. the grid does NOT do this for you in the
// refreshInfiniteCache() method, as this would be assuming you want to do it which
// is not true, maybe the row count is constant and you just want to refresh the details.
const maxRowFound = gridRef.current!.api.isLastRowIndexKnown();
if (maxRowFound) {
const rowCount = gridRef.current!.api.getDisplayedRowCount() || 0;
gridRef.current!.api.setRowCount(rowCount + count);
}
// get grid to refresh the data
gridRef.current!.api.refreshInfiniteCache();
}, []);
const removeItem = useCallback(
(start: number, limit: number) => {
allOfTheData.splice(start, limit);
gridRef.current!.api.refreshInfiniteCache();
},
[allOfTheData],
);
const refreshCache = useCallback(() => {
gridRef.current!.api.refreshInfiniteCache();
}, []);
const purgeCache = useCallback(() => {
gridRef.current!.api.purgeInfiniteCache();
}, []);
const setRowCountTo200 = useCallback(() => {
gridRef.current!.api.setRowCount(200, false);
}, []);
const rowsAndMaxFound = useCallback(() => {
console.log(
"getDisplayedRowCount() => " +
gridRef.current!.api.getDisplayedRowCount(),
);
console.log(
"isLastRowIndexKnown() => " + gridRef.current!.api.isLastRowIndexKnown(),
);
}, []);
// function just gives new prices to the row data, it does not update the grid
const setPricesHigh = useCallback(() => {
allOfTheData.forEach(function (dataItem) {
dataItem.price = Math.round(55500 + 400 * (0.5 + window.agRandom()));
});
}, [allOfTheData]);
const setPricesLow = useCallback(() => {
allOfTheData.forEach(function (dataItem) {
dataItem.price = Math.round(1000 + 100 * (0.5 + window.agRandom()));
});
}, [allOfTheData]);
const jumpTo500 = useCallback(() => {
// first up, need to make sure the grid is actually showing 500 or more rows
if ((gridRef.current!.api.getDisplayedRowCount() || 0) < 501) {
gridRef.current!.api.setRowCount(501, false);
}
// next, we can jump to the row
gridRef.current!.api.ensureIndexVisible(500);
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div
style={{ display: "flex", flexDirection: "column", height: "100%" }}
>
<div style={{ marginBottom: "10px" }}>
<button onClick={() => insertItemsAt2AndRefresh(5)}>
Insert Rows
</button>
<button onClick={() => removeItem(3, 10)}>Delete Rows</button>
<button onClick={setRowCountTo200}>Set Row Count</button>
<button onClick={rowsAndMaxFound}>Print Info</button>
<button onClick={jumpTo500}>Jump to 500</button>
</div>
<div style={{ marginBottom: "10px" }}>
<button onClick={setPricesHigh}>Set Prices High</button>
<button onClick={setPricesLow}>Set Prices Low</button>
<button onClick={refreshCache}>Refresh Cache</button>
<button onClick={purgeCache}>Purge Cache</button>
</div>
<div style={{ flexGrow: "1" }}>
<div style={gridStyle}>
<AgGridReact
ref={gridRef}
columnDefs={columnDefs}
datasource={datasource}
defaultColDef={defaultColDef}
rowModelType={"infinite"}
maxBlocksInCache={2}
infiniteInitialRowCount={500}
maxConcurrentDatasourceRequests={2}
getRowId={getRowId}
getRowStyle={getRowStyle}
onGridReady={onGridReady}
/>
</div>
</div>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
Changing Columns Copy Link
Changing columns is possible using infinite scroll and it does not require the data getting fetched again from the server. If the change of columns impacts the sort or filter (i.e. a column with a sort or filter applied is removed), the grid will fetch data again similar to how data is fetched again after the user changes the sort or filter explicitly.
The example below demonstrates changing columns on the infinite row model. The following can be noted:
- Hit the buttons 'Show Year' and 'Hide Year'. Notice that the data is not re-fetched.
- Add a sort or filter to Age column. When the sort or filter is applied the data is re-fetched. However once fetched, you can add and remove the Year column without re-fetching the data.
- Add a sort or filter to the Year column. When the sort or filter is applied the data is re-fetched. Now remove the Year column and the data is re-fetched again as the sort or filter has changed.
("use client");
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./style.css";
import {
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
IDatasource,
InfiniteRowModelModule,
ModuleRegistry,
RowModelType,
SortModelItem,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [TextFilterModule, InfiniteRowModelModule];
function sortAndFilter(
allOfTheData: any[],
sortModel: SortModelItem[],
filterModel: any,
) {
return sortData(sortModel, filterData(filterModel, allOfTheData));
}
function sortData(sortModel: SortModelItem[], data: any[]) {
const sortPresent = sortModel && sortModel.length > 0;
if (!sortPresent) {
return data;
}
// do an in memory sort of the data, across all the fields
const resultOfSort = data.slice();
resultOfSort.sort(function (a, b) {
for (let k = 0; k < sortModel.length; k++) {
const sortColModel = sortModel[k];
const valueA = a[sortColModel.colId];
const valueB = b[sortColModel.colId];
// this filter didn't find a difference, move onto the next one
if (valueA == valueB) {
continue;
}
const sortDirection = sortColModel.sort === "asc" ? 1 : -1;
if (valueA > valueB) {
return sortDirection;
} else {
return sortDirection * -1;
}
}
// no filters found a difference
return 0;
});
return resultOfSort;
}
function filterData(filterModel: any, data: any[]) {
const filterPresent = filterModel && Object.keys(filterModel).length > 0;
if (!filterPresent) {
return data;
}
const resultOfFilter = [];
for (let i = 0; i < data.length; i++) {
var item = data[i];
var filterFails = false;
const filterKeys = Object.keys(filterModel);
filterKeys.forEach((filterKey) => {
const filterValue = filterModel[filterKey].filter;
const valueForRow = item[filterKey];
if (filterValue != valueForRow) {
// year didn't match, so skip this record
filterFails = true;
}
});
// if (filterModel.year) {
// var val1 = filterModel.year.filter;
// var val2 = item.year;
// if (val1 != val2) {
// // year didn't match, so skip this record
// continue;
// }
// }
//
if (!filterFails) {
resultOfFilter.push(item);
}
}
return resultOfFilter;
}
const GridExample = () => {
const gridRef = useRef<AgGridReact<IOlympicData>>(null);
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "athlete", colId: "athlete", minWidth: 180 },
{ field: "age", colId: "age" },
{ field: "country", colId: "country", minWidth: 180 },
{ field: "year", colId: "year" },
{ field: "sport", colId: "sport", minWidth: 180 },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
filter: true,
};
}, []);
const onGridReady = useCallback((params: GridReadyEvent) => {
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data: IOlympicData[]) => {
// give each row an id
data.forEach(function (d: any, index: number) {
d.id = "R" + (index + 1);
});
const dataSource: IDatasource = {
rowCount: undefined, // behave as infinite scroll
getRows: (params) => {
console.log(
"asking for " + params.startRow + " to " + params.endRow,
);
// At this point in your code, you would call the server.
// To make the demo look real, wait for 500ms before returning
setTimeout(() => {
// take a slice of the total rows
const dataAfterSortingAndFiltering = sortAndFilter(
data,
params.sortModel,
params.filterModel,
);
const rowsThisPage = dataAfterSortingAndFiltering.slice(
params.startRow,
params.endRow,
);
// if on or after the last page, work out the last row.
let lastRow = -1;
if (dataAfterSortingAndFiltering.length <= params.endRow) {
lastRow = dataAfterSortingAndFiltering.length;
}
// call the success callback
params.successCallback(rowsThisPage, lastRow);
}, 500);
},
};
params.api!.setGridOption("datasource", dataSource);
});
}, []);
const onBtShowYearColumn = useCallback(() => {
gridRef.current!.api.setGridOption("columnDefs", [
{ field: "athlete", colId: "athlete" },
{ field: "age", colId: "age" },
{ field: "country", colId: "country" },
{ field: "year", colId: "year" },
{ field: "sport", colId: "sport" },
]);
}, []);
const onBtHideYearColumn = useCallback(() => {
gridRef.current!.api.setGridOption("columnDefs", [
{ field: "athlete", colId: "athlete" },
{ field: "age", colId: "age" },
{ field: "country", colId: "country" },
{ field: "sport", colId: "sport" },
]);
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div className="test-container">
<div className="test-header">
<button onClick={onBtShowYearColumn}>Show Year</button>
<button onClick={onBtHideYearColumn}>Hide Year</button>
</div>
<div style={gridStyle} className="test-grid">
<AgGridReact<IOlympicData>
ref={gridRef}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
rowModelType={"infinite"}
onGridReady={onGridReady}
/>
</div>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.test-grid {
height: 1px;
min-height: 1px;
flex-grow: 1;
}
.test-container {
height: 100%;
display: flex;
flex-direction: column;
}
.test-header {
margin-bottom: 5px;
}
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Pagination Copy Link
As with all row models, it is possible to enable pagination with infinite scrolling. With infinite scrolling, it is possible to mix and match with the configuration to achieve different effects. The following examples are presented:
| Example | Page Size | Block Size | Comment |
|---|---|---|---|
| Example 1 | Auto | Large | Most Recommended |
| Example 2 | Equal | Equal | Recommended Sometimes |
Having smaller infinite blocks size than your pagination page size is not supported
You must have infinite block size greater than or equal to the pagination page size. If you have a smaller block size, the grid will not fetch enough rows to display one page. This breaks how infinite scrolling works and is not supported.
Example 1: Auto Pagination Page Size, Large Infinite Block Size Copy Link
This example is the recommended approach. The infinite block size is larger than the pages size, so the grid loads data for a few pages, allowing the user to hit 'next' a few times before a server sided call is needed.
'use client';
import React, { StrictMode, useCallback, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";
import type {
ColDef,
GetRowIdParams,
GridReadyEvent,
IDatasource,
} from "ag-grid-community";
import {
InfiniteRowModelModule,
NumberFilterModule,
PaginationModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
SetFilterModule,
} from "ag-grid-enterprise";
import type { CustomCellRendererProps } from "ag-grid-react";
import { AgGridProvider, AgGridReact } from "ag-grid-react";
import { countries } from "./countries";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
NumberFilterModule,
PaginationModule,
InfiniteRowModelModule,
SetFilterModule,
ColumnMenuModule,
ContextMenuModule,
ColumnsToolPanelModule,
];
const filterParams = { values: countries() };
const sortAndFilter = (
allOfTheData: any[],
sortModel: any,
filterModel: any,
) => {
return sortData(sortModel, filterData(filterModel, allOfTheData));
};
const sortData = (sortModel: any, data: any[]) => {
const sortPresent = sortModel && sortModel.length > 0;
if (!sortPresent) {
return data;
}
// do an in memory sort of the data, across all the fields
const resultOfSort = data.slice();
resultOfSort.sort(function (a, b) {
for (let k = 0; k < sortModel.length; k++) {
const sortColModel = sortModel[k];
const valueA = a[sortColModel.colId];
const valueB = b[sortColModel.colId];
// this filter didn't find a difference, move onto the next one
if (valueA == valueB) {
continue;
}
const sortDirection = sortColModel.sort === "asc" ? 1 : -1;
if (valueA > valueB) {
return sortDirection;
} else {
return sortDirection * -1;
}
}
// no filters found a difference
return 0;
});
return resultOfSort;
};
const filterData = (filterModel: any, data: any[]) => {
const filterPresent = filterModel && Object.keys(filterModel).length > 0;
if (!filterPresent) {
return data;
}
const resultOfFilter = [];
for (let i = 0; i < data.length; i++) {
const item = data[i];
if (filterModel.age) {
const age = item.age;
const allowedAge = parseInt(filterModel.age.filter);
// EQUALS = 1;
// LESS_THAN = 2;
// GREATER_THAN = 3;
if (filterModel.age.type == "equals") {
if (age !== allowedAge) {
continue;
}
} else if (filterModel.age.type == "lessThan") {
if (age >= allowedAge) {
continue;
}
} else {
if (age <= allowedAge) {
continue;
}
}
}
if (filterModel.year) {
if (filterModel.year.values.indexOf(item.year.toString()) < 0) {
// year didn't match, so skip this record
continue;
}
}
if (filterModel.country) {
if (filterModel.country.values.indexOf(item.country) < 0) {
continue;
}
}
resultOfFilter.push(item);
}
return resultOfFilter;
};
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
// this row just shows the row index, doesn't use any data from the row
{
headerName: "ID",
maxWidth: 100,
valueGetter: "node.id",
cellRenderer: (props: CustomCellRendererProps) => {
if (props.value !== undefined) {
return props.value;
} else {
return (
<img src="https://www.ag-grid.com/example-assets/loading.gif" />
);
}
},
// we don't want to sort by the row index, this doesn't make sense as the point
// of the row index is to know the row index in what came back from the server
sortable: false,
suppressHeaderMenuButton: true,
},
{ headerName: "Athlete", field: "athlete", suppressHeaderMenuButton: true },
{
field: "age",
filter: "agNumberColumnFilter",
filterParams: {
filterOptions: ["equals", "lessThan", "greaterThan"],
},
},
{
field: "country",
filter: "agSetColumnFilter",
filterParams: filterParams,
},
{
field: "year",
filter: "agSetColumnFilter",
filterParams: { values: ["2000", "2004", "2008", "2012"] },
},
{ field: "date" },
{ field: "sport", suppressHeaderMenuButton: true },
{ field: "gold", suppressHeaderMenuButton: true },
{ field: "silver", suppressHeaderMenuButton: true },
{ field: "bronze", suppressHeaderMenuButton: true },
{ field: "total", suppressHeaderMenuButton: true },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 150,
floatingFilter: true,
};
}, []);
const getRowId = useCallback(function (params: GetRowIdParams) {
return params.data.id;
}, []);
const onGridReady = useCallback((params: GridReadyEvent) => {
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data: any[]) => {
data.forEach(function (d, index) {
d.id = "R" + (index + 1);
});
const dataSource: IDatasource = {
rowCount: undefined,
getRows: (params) => {
console.log(
"asking for " + params.startRow + " to " + params.endRow,
);
// At this point in your code, you would call the server.
// To make the demo look real, wait for 500ms before returning
setTimeout(function () {
// take a slice of the total rows
const dataAfterSortingAndFiltering = sortAndFilter(
data,
params.sortModel,
params.filterModel,
);
const rowsThisPage = dataAfterSortingAndFiltering.slice(
params.startRow,
params.endRow,
);
// if on or after the last page, work out the last row.
let lastRow = -1;
if (dataAfterSortingAndFiltering.length <= params.endRow) {
lastRow = dataAfterSortingAndFiltering.length;
}
// call the success callback
params.successCallback(rowsThisPage, lastRow);
}, 500);
},
};
params.api.setGridOption("datasource", dataSource);
});
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact
columnDefs={columnDefs}
defaultColDef={defaultColDef}
rowModelType={"infinite"}
cacheBlockSize={100}
cacheOverflowSize={2}
maxConcurrentDatasourceRequests={2}
infiniteInitialRowCount={1}
maxBlocksInCache={2}
pagination={true}
paginationAutoPageSize={true}
getRowId={getRowId}
onGridReady={onGridReady}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export function countries() {
return [
"United States",
"Russia",
"Australia",
"Canada",
"Norway",
"China",
"Zimbabwe",
"Netherlands",
"South Korea",
"Croatia",
"France",
"Japan",
"Hungary",
"Germany",
"Poland",
"South Africa",
"Sweden",
"Ukraine",
"Italy",
"Czech Republic",
"Austria",
"Finland",
"Romania",
"Great Britain",
"Jamaica",
"Singapore",
"Belarus",
"Chile",
"Spain",
"Tunisia",
"Brazil",
"Slovakia",
"Costa Rica",
"Bulgaria",
"Switzerland",
"New Zealand",
"Estonia",
"Kenya",
"Ethiopia",
"Trinidad and Tobago",
"Turkey",
"Morocco",
"Bahamas",
"Slovenia",
"Armenia",
"Azerbaijan",
"India",
"Puerto Rico",
"Egypt",
"Kazakhstan",
"Iran",
"Georgia",
"Lithuania",
"Cuba",
"Colombia",
"Mongolia",
"Uzbekistan",
"North Korea",
"Tajikistan",
"Kyrgyzstan",
"Greece",
"Macedonia",
"Moldova",
"Chinese Taipei",
"Indonesia",
"Thailand",
"Vietnam",
"Latvia",
"Venezuela",
"Mexico",
"Nigeria",
"Qatar",
"Serbia",
"Serbia and Montenegro",
"Hong Kong",
"Denmark",
"Portugal",
"Argentina",
"Afghanistan",
"Gabon",
"Dominican Republic",
"Belgium",
"Kuwait",
"United Arab Emirates",
"Cyprus",
"Israel",
"Algeria",
"Montenegro",
"Iceland",
"Paraguay",
"Cameroon",
"Saudi Arabia",
"Ireland",
"Malaysia",
"Uruguay",
"Togo",
"Mauritius",
"Syria",
"Botswana",
"Guatemala",
"Bahrain",
"Grenada",
"Uganda",
"Sudan",
"Ecuador",
"Panama",
"Eritrea",
"Sri Lanka",
"Mozambique",
"Barbados",
];
}
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Example 2: Equal Pagination Page Size and Large Infinite Block Size Copy Link
This example demonstrates having the page and block sizes equal. Here the server is hit every time a new page is navigated to.
'use client';
import React, { StrictMode, useCallback, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";
import type {
ColDef,
GetRowIdParams,
GridReadyEvent,
IDatasource,
} from "ag-grid-community";
import {
InfiniteRowModelModule,
NumberFilterModule,
PaginationModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
SetFilterModule,
} from "ag-grid-enterprise";
import type { CustomCellRendererProps } from "ag-grid-react";
import { AgGridProvider, AgGridReact } from "ag-grid-react";
import { countries } from "./countries";
import "./styles.css";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
NumberFilterModule,
PaginationModule,
InfiniteRowModelModule,
SetFilterModule,
ColumnMenuModule,
ContextMenuModule,
ColumnsToolPanelModule,
];
const filterParams = { values: countries() };
const sortAndFilter = (
allOfTheData: any[],
sortModel: any,
filterModel: any,
) => {
return sortData(sortModel, filterData(filterModel, allOfTheData));
};
const sortData = (sortModel: any, data: any[]) => {
const sortPresent = sortModel && sortModel.length > 0;
if (!sortPresent) {
return data;
}
// do an in memory sort of the data, across all the fields
const resultOfSort = data.slice();
resultOfSort.sort(function (a, b) {
for (let k = 0; k < sortModel.length; k++) {
const sortColModel = sortModel[k];
const valueA = a[sortColModel.colId];
const valueB = b[sortColModel.colId];
// this filter didn't find a difference, move onto the next one
if (valueA == valueB) {
continue;
}
const sortDirection = sortColModel.sort === "asc" ? 1 : -1;
if (valueA > valueB) {
return sortDirection;
} else {
return sortDirection * -1;
}
}
// no filters found a difference
return 0;
});
return resultOfSort;
};
const filterData = (filterModel: any, data: any[]) => {
const filterPresent = filterModel && Object.keys(filterModel).length > 0;
if (!filterPresent) {
return data;
}
const resultOfFilter = [];
for (let i = 0; i < data.length; i++) {
const item = data[i];
if (filterModel.age) {
const age = item.age;
const allowedAge = parseInt(filterModel.age.filter);
// EQUALS = 1;
// LESS_THAN = 2;
// GREATER_THAN = 3;
if (filterModel.age.type == "equals") {
if (age !== allowedAge) {
continue;
}
} else if (filterModel.age.type == "lessThan") {
if (age >= allowedAge) {
continue;
}
} else {
if (age <= allowedAge) {
continue;
}
}
}
if (filterModel.year) {
if (filterModel.year.values.indexOf(item.year.toString()) < 0) {
// year didn't match, so skip this record
continue;
}
}
if (filterModel.country) {
if (filterModel.country.values.indexOf(item.country) < 0) {
continue;
}
}
resultOfFilter.push(item);
}
return resultOfFilter;
};
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
// this row just shows the row index, doesn't use any data from the row
{
headerName: "ID",
maxWidth: 100,
valueGetter: "node.id",
cellRenderer: (props: CustomCellRendererProps) => {
if (props.value !== undefined) {
return props.value;
} else {
return (
<img src="https://www.ag-grid.com/example-assets/loading.gif" />
);
}
},
// we don't want to sort by the row index, this doesn't make sense as the point
// of the row index is to know the row index in what came back from the server
sortable: false,
suppressHeaderMenuButton: true,
},
{
headerName: "Athlete",
field: "athlete",
width: 150,
suppressHeaderMenuButton: true,
},
{
field: "age",
filter: "agNumberColumnFilter",
filterParams: {
filterOptions: ["equals", "lessThan", "greaterThan"],
},
},
{
field: "country",
filter: "agSetColumnFilter",
filterParams: filterParams,
},
{
field: "year",
filter: "agSetColumnFilter",
filterParams: { values: ["2000", "2004", "2008", "2012"] },
},
{ field: "date" },
{ field: "sport", suppressHeaderMenuButton: true },
{ field: "gold", suppressHeaderMenuButton: true },
{ field: "silver", suppressHeaderMenuButton: true },
{ field: "bronze", suppressHeaderMenuButton: true },
{ field: "total", suppressHeaderMenuButton: true },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 150,
floatingFilter: true,
};
}, []);
const getRowId = useCallback(function (params: GetRowIdParams) {
return params.data.id;
}, []);
const onGridReady = useCallback((params: GridReadyEvent) => {
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data: any[]) => {
// give each row an id
data.forEach(function (x, index) {
x.id = "R" + (index + 1);
});
const dataSource: IDatasource = {
rowCount: undefined,
getRows: (params) => {
console.log(
"asking for " + params.startRow + " to " + params.endRow,
);
// At this point in your code, you would call the server
// To make the demo look real, wait for 500ms before returning
setTimeout(function () {
// take a slice of the total rows
const dataAfterSortingAndFiltering = sortAndFilter(
data,
params.sortModel,
params.filterModel,
);
const rowsThisPage = dataAfterSortingAndFiltering.slice(
params.startRow,
params.endRow,
);
// if on or after the last page, work out the last row.
let lastRow = -1;
if (dataAfterSortingAndFiltering.length <= params.endRow) {
lastRow = dataAfterSortingAndFiltering.length;
}
// call the success callback
params.successCallback(rowsThisPage, lastRow);
}, 500);
},
};
params.api.setGridOption("datasource", dataSource);
});
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact
columnDefs={columnDefs}
defaultColDef={defaultColDef}
rowModelType={"infinite"}
cacheOverflowSize={2}
maxConcurrentDatasourceRequests={2}
infiniteInitialRowCount={1}
maxBlocksInCache={2}
pagination={true}
getRowId={getRowId}
onGridReady={onGridReady}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
width: 100%;
}
export function countries() {
return [
"United States",
"Russia",
"Australia",
"Canada",
"Norway",
"China",
"Zimbabwe",
"Netherlands",
"South Korea",
"Croatia",
"France",
"Japan",
"Hungary",
"Germany",
"Poland",
"South Africa",
"Sweden",
"Ukraine",
"Italy",
"Czech Republic",
"Austria",
"Finland",
"Romania",
"Great Britain",
"Jamaica",
"Singapore",
"Belarus",
"Chile",
"Spain",
"Tunisia",
"Brazil",
"Slovakia",
"Costa Rica",
"Bulgaria",
"Switzerland",
"New Zealand",
"Estonia",
"Kenya",
"Ethiopia",
"Trinidad and Tobago",
"Turkey",
"Morocco",
"Bahamas",
"Slovenia",
"Armenia",
"Azerbaijan",
"India",
"Puerto Rico",
"Egypt",
"Kazakhstan",
"Iran",
"Georgia",
"Lithuania",
"Cuba",
"Colombia",
"Mongolia",
"Uzbekistan",
"North Korea",
"Tajikistan",
"Kyrgyzstan",
"Greece",
"Macedonia",
"Moldova",
"Chinese Taipei",
"Indonesia",
"Thailand",
"Vietnam",
"Latvia",
"Venezuela",
"Mexico",
"Nigeria",
"Qatar",
"Serbia",
"Serbia and Montenegro",
"Hong Kong",
"Denmark",
"Portugal",
"Argentina",
"Afghanistan",
"Gabon",
"Dominican Republic",
"Belgium",
"Kuwait",
"United Arab Emirates",
"Cyprus",
"Israel",
"Algeria",
"Montenegro",
"Iceland",
"Paraguay",
"Cameroon",
"Saudi Arabia",
"Ireland",
"Malaysia",
"Uruguay",
"Togo",
"Mauritius",
"Syria",
"Botswana",
"Guatemala",
"Bahrain",
"Grenada",
"Uganda",
"Sudan",
"Ecuador",
"Panama",
"Eritrea",
"Sri Lanka",
"Mozambique",
"Barbados",
];
}
Overlays Copy Link
The infinite row model does not automatically show the loading overlay as rows are loaded in blocks as the user interacts with the grid. The grid will show the no rows overlay if the datasource returns an empty array and the no matching rows overlay if an empty array is returned while filters are set.
For configuration details, including suppressing the built in overlays, see Overlays.

If you are an Enterprise user you should consider using the Server-Side Row Model instead of the Infinite Row Model. It offers the same functionality with many more features. The differences between row models can be found in our row models summary page.
Infinite scrolling allows the grid to lazy-load rows from the server depending on what the scroll position is of the grid. In its simplest form, the more the user scrolls down, the more rows get loaded.
The grid will have an 'auto extending' vertical scroll. That means as the scroll reaches the bottom position, the grid will extend the height to allow scrolling even further down, almost making it impossible for the user to reach the bottom. This will stop happening once the grid has extended the scroll to reach the last record in the table.
How it Works Copy Link
The grid will ask your application, via a datasource, for the rows in blocks. Each block contains a subset of rows of the entire dataset. The following diagram is a high-level overview.
When the grid scrolls to a position where there is no corresponding block of rows loaded, the model uses the provided datasource to get the rows for the requested block. In the diagram, the datasource is getting the rows from a database in a remote server.
Turning On Infinite Scrolling Copy Link
To turn on infinite scrolling, you must a) set the grid property rowModelType to 'infinite' and b) provide a datasource.
// before grid initialised
gridOptions.rowModelType = 'infinite';
gridOptions.datasource = myDataSource;
// after grid initialised, you can set or change the datasource
api.setGridOption('datasource', myDataSource); Datasource Copy Link
A datasource must be provided to do infinite scrolling. You specify the datasource as a grid property or using the grid API.
// set as a property
gridOptions.datasource = myDatasource;
// or use the api after the grid is initialised
api.setGridOption('datasource', myDatasource); Changing the Datasource Copy Link
Changing the datasource after the grid is initialised will reset the infinite scrolling in the grid. This is useful if the context of your data changes, i.e. if you want to look at a different set of data.
If you call setGridOption('datasource', datasource) the grid will act assuming it's a new datasource, resetting the block cache. However you can pass in the same datasource instance. So your application, for example, might have one instance of a datasource that is aware of some external context (e.g. the business date selected for a report, or the 'bank ATM instance' data you are connecting to), and when the context changes, you want to reset, but still keep the same datasource instance. In this case, just call setGridOption('datasource', datasource) and pass the same datasource in again.
Datasource Interface Copy Link
In a nutshell, every time the grid wants more rows, it will call getRows() on the datasource. The datasource responds with the rows requested. Your datasource for infinite scrolling should implement the IDatasource interface:
Properties available on the IDatasource interface.
If you know up front how many rows are in the dataset, set it here. Otherwise leave blank. |
Callback the grid calls that you implement to fetch rows from the server. |
Optional destroy method, if your datasource has state it needs to clean up. |
The getRows() method takes the IGetRowsParams parameters:
Properties available on the IGetRowsParams<TData = any, TContext = any> interface.
The first row index to get. |
The first row index to NOT get. |
Callback to call for the result when successful. |
Callback to call when the request fails. |
If doing server side sorting, contains the sort model |
If doing server side filtering, contains the filter model |
The grid api. |
Application context as set on gridOptions.context. |
getRows() Copy Link
The getRows() function is called by the grid to load a block of rows into the browser-side cache of blocks. It takes the following as parameters:
The
startRowandendRowdefine the range expected for the call. For example, if thegetRowsfunction is called withstartRow: 0andendRow: 100, then the grid will expect a result with 100 rows (rows 0 to 99).The
successCallback(rowsThisBlock, lastRow)should be called when you successfully receive data from the server. The callback has the following parameters:rowsThisBlockshould be the rows you have received for the current block.lastRowshould be the index of the last row if known.
The
failCallback()should be called if the loading failed. Either one ofsuccessCallback()orfailCallback()should be called exactly once.The
filterModel()andsortModel()are passed for doing server-side sorting and filtering.The context is just passed as is and nothing to do with infinite scrolling. It's there if you need it for providing application state to your datasource.
Setting Last Row Index Copy Link
The success callback parameter lastRow is used to move the grid out of infinite scrolling. If the last row is known, then this should be the index of the last row. If the last row is unknown, then leave blank (undefined, null or -1). This attribute is only used when in infinite scrolling. Once the total record count is known, the lastRow parameter will be ignored.
Under normal operation, you will return null or undefined for lastRow for every time getRows() is called with the exception of when you get to the last block. For example, if block size is 100 and you have 250 rows, when getRows() is called for the third time, you will return back 50 rows in the result and set rowCount to 250. This will then get the grid to set the scrollbar to fit exactly 250 rows and will not ask for any more blocks.
Block Cache Copy Link
The grid keeps the blocks in a cache. You have the choice to never expire the blocks, or to set a limit to the number of blocks kept. If you set a limit, then as you scroll down, previous blocks will be discarded and will be loaded again if the user scrolls back up. The maximum blocks to keep in the cache is set using the maxBlocksInCache property.
Block Size Copy Link
The block size is set using the grid property cacheBlockSize. This is how many rows each block in the cache should contain. Each call to your datasource will be for one block.
Debounce Block Loading Copy Link
It is also possible to debounce the loading to prevent blocks loading until scrolling has stopped. This can be configured using: blockLoadDebounceMillis.
Aggregation and Grouping Copy Link
Aggregation and grouping are not available in infinite scrolling. This is because to do so would require the grid knowing the entire dataset, which is not possible when using the Infinite Row Model. If you need aggregation and / or grouping for large datasets, check the Server-Side Row Model for doing aggregations on the server-side.
Sorting & Filtering Copy Link
The grid cannot do sorting or filtering for you, as it does not have all of the data. Sorting or filtering must be done on the server-side. For this reason, if the sort or filter changes, the grid will use the datasource to get the data again and provide the sort and filter state to you.
Simple Example: No Sorting or Filtering Copy Link
The example below makes use of infinite scrolling and caching. Notice that the grid will load more data when you bring the scroll all the way to the bottom.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ICellRendererParams,
IDatasource,
IGetRowsParams,
InfiniteRowModelModule,
ModuleRegistry,
RowModelType,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([InfiniteRowModelModule]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowBuffer]="rowBuffer"
[rowModelType]="rowModelType"
[cacheBlockSize]="cacheBlockSize"
[cacheOverflowSize]="cacheOverflowSize"
[maxConcurrentDatasourceRequests]="maxConcurrentDatasourceRequests"
[infiniteInitialRowCount]="infiniteInitialRowCount"
[maxBlocksInCache]="maxBlocksInCache"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
// this row shows the row index, doesn't use any data from the row
{
headerName: "ID",
maxWidth: 100,
// it is important to have node.id here, so that when the id changes (which happens
// when the row is loaded) then the cell is refreshed.
valueGetter: "node.id",
cellRenderer: (params: ICellRendererParams) => {
if (params.value !== undefined) {
return params.value;
} else {
return '<img src="https://www.ag-grid.com/example-assets/loading.gif">';
}
},
},
{ field: "athlete", minWidth: 150 },
{ field: "age" },
{ field: "country", minWidth: 150 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 100,
sortable: false,
};
rowBuffer = 0;
rowModelType: RowModelType = "infinite";
cacheBlockSize = 100;
cacheOverflowSize = 2;
maxConcurrentDatasourceRequests = 1;
infiniteInitialRowCount = 1000;
maxBlocksInCache = 10;
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => {
const dataSource: IDatasource = {
rowCount: undefined, // behave as infinite scroll
getRows: (params: IGetRowsParams) => {
console.log(
"asking for " + params.startRow + " to " + params.endRow,
);
// At this point in your code, you would call the server.
// To make the demo look real, wait for 500ms before returning
setTimeout(() => {
// take a slice of the total rows
const rowsThisPage = data.slice(params.startRow, params.endRow);
// if on or after the last page, work out the last row.
let lastRow = -1;
if (data.length <= params.endRow) {
lastRow = data.length;
}
// call the success callback
params.successCallback(rowsThisPage, lastRow);
}, 500);
},
};
params.api!.setGridOption("datasource", dataSource);
});
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Selection Copy Link
Selection works on the rows in infinite scrolling by using the Row IDs of the Row Nodes. If you do not provide Keys for the Row Nodes, the index of the Row Node will be used. Using the index of the row breaks down when (server-side) filtering or sorting, as these change the index of the Rows. For this reason, if you do not provide your own Row IDs, then selection is cleared if sort or filter is changed.
To provide your own Row IDs, implement the method getRowId(params), which should return the Key for the data.
gridOptions.getRowId: function(params) {
// the ID can be any string, as long as it's unique within your dataset
return params.data.id.toString();
}Once you have getRowId() implemented, selection will persist across sorts and filters.
The infinite row model does not have built-in support for Select-All functionality. Neither clicking the header checkbox nor pressing ^ Ctrl⌘ Command+A will have any effect.
Example: Sorting, Filtering and Selection Copy Link
The following example extends the example above by adding server-side sorting, filtering and persistent selection.
Any column can be sorted by clicking the header. When this happens, the datasource is called again with the new sort options.
The columns Age, Country and Year can be filtered. When this happens, the datasource is called again with the new filtering options.
When a row is selected, the selection will remain inside the grid, even if the grid gets sorted or filtered. Notice that when the grid loads a selected row (e.g. select first row, scroll down so the first block is removed from cache, then scroll back up again) the row is not highlighted until the row is loaded from the server. This is because the grid is waiting to see what the ID is of the row to be loaded.
The example below uses AG Grid Enterprise, to demonstrate the set filter with server-side filtering. AG Grid Enterprise is not required for infinite scrolling.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
ColDef,
ColGroupDef,
GetRowIdFunc,
GetRowIdParams,
GridApi,
GridOptions,
GridReadyEvent,
ICellRendererParams,
IDatasource,
IGetRowsParams,
InfiniteRowModelModule,
ModuleRegistry,
NumberFilterModule,
RowModelType,
RowSelectionModule,
RowSelectionOptions,
SortModelItem,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { getCountries } from "./countries";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
RowSelectionModule,
ColumnsToolPanelModule,
InfiniteRowModelModule,
ColumnMenuModule,
ContextMenuModule,
SetFilterModule,
NumberFilterModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowSelection]="rowSelection"
[rowModelType]="rowModelType"
[cacheBlockSize]="cacheBlockSize"
[cacheOverflowSize]="cacheOverflowSize"
[maxConcurrentDatasourceRequests]="maxConcurrentDatasourceRequests"
[infiniteInitialRowCount]="infiniteInitialRowCount"
[maxBlocksInCache]="maxBlocksInCache"
[getRowId]="getRowId"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
// this row just shows the row index, doesn't use any data from the row
{
headerName: "ID",
maxWidth: 100,
valueGetter: "node.id",
cellRenderer: (params: ICellRendererParams) => {
if (params.value !== undefined) {
return params.value;
} else {
return '<img src="https://www.ag-grid.com/example-assets/loading.gif">';
}
},
// we don't want to sort by the row index, this doesn't make sense as the point
// of the row index is to know the row index in what came back from the server
sortable: false,
suppressHeaderMenuButton: true,
},
{ field: "athlete", suppressHeaderMenuButton: true },
{
field: "age",
filter: "agNumberColumnFilter",
filterParams: {
filterOptions: ["equals", "lessThan", "greaterThan"],
maxNumConditions: 1,
},
},
{
field: "country",
filter: "agSetColumnFilter",
filterParams: filterParams,
},
{
field: "year",
filter: "agSetColumnFilter",
filterParams: { values: ["2000", "2004", "2008", "2012"] },
},
{ field: "date" },
{ field: "sport", suppressHeaderMenuButton: true },
{ field: "gold", suppressHeaderMenuButton: true },
{ field: "silver", suppressHeaderMenuButton: true },
{ field: "bronze", suppressHeaderMenuButton: true },
{ field: "total", suppressHeaderMenuButton: true },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 150,
floatingFilter: true,
};
rowSelection: RowSelectionOptions | "single" | "multiple" = {
mode: "multiRow",
headerCheckbox: false,
};
rowModelType: RowModelType = "infinite";
cacheBlockSize = 100;
cacheOverflowSize = 2;
maxConcurrentDatasourceRequests = 2;
infiniteInitialRowCount = 1;
maxBlocksInCache = 2;
getRowId: GetRowIdFunc = (params: GetRowIdParams) => {
return params.data.id;
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => {
// give each row an id
data.forEach(function (d: any, index: number) {
d.id = "R" + (index + 1);
});
const dataSource: IDatasource = {
rowCount: undefined, // behave as infinite scroll
getRows: (params: IGetRowsParams) => {
console.log(
"asking for " + params.startRow + " to " + params.endRow,
);
// At this point in your code, you would call the server.
// To make the demo look real, wait for 500ms before returning
setTimeout(() => {
// take a slice of the total rows
const dataAfterSortingAndFiltering = sortAndFilter(
data,
params.sortModel,
params.filterModel,
);
const rowsThisPage = dataAfterSortingAndFiltering.slice(
params.startRow,
params.endRow,
);
// if on or after the last page, work out the last row.
let lastRow = -1;
if (dataAfterSortingAndFiltering.length <= params.endRow) {
lastRow = dataAfterSortingAndFiltering.length;
}
// call the success callback
params.successCallback(rowsThisPage, lastRow);
}, 500);
},
};
params.api!.setGridOption("datasource", dataSource);
});
}
}
const filterParams = { values: getCountries() };
function sortAndFilter(
allOfTheData: any,
sortModel: SortModelItem[],
filterModel: any,
) {
return sortData(sortModel, filterData(filterModel, allOfTheData));
}
function sortData(sortModel: SortModelItem[], data: any[]) {
const sortPresent = sortModel && sortModel.length > 0;
if (!sortPresent) {
return data;
}
// do an in memory sort of the data, across all the fields
const resultOfSort = data.slice();
resultOfSort.sort(function (a, b) {
for (let k = 0; k < sortModel.length; k++) {
const sortColModel = sortModel[k];
const valueA = a[sortColModel.colId];
const valueB = b[sortColModel.colId];
// this filter didn't find a difference, move onto the next one
if (valueA == valueB) {
continue;
}
const sortDirection = sortColModel.sort === "asc" ? 1 : -1;
if (valueA > valueB) {
return sortDirection;
} else {
return sortDirection * -1;
}
}
// no filters found a difference
return 0;
});
return resultOfSort;
}
function filterData(filterModel: any, data: any[]) {
const filterPresent = filterModel && Object.keys(filterModel).length > 0;
if (!filterPresent) {
return data;
}
const resultOfFilter = [];
for (let i = 0; i < data.length; i++) {
const item = data[i];
if (filterModel.age) {
const age = item.age;
const allowedAge = parseInt(filterModel.age.filter);
// EQUALS = 1;
// LESS_THAN = 2;
// GREATER_THAN = 3;
if (filterModel.age.type == "equals") {
if (age !== allowedAge) {
continue;
}
} else if (filterModel.age.type == "lessThan") {
if (age >= allowedAge) {
continue;
}
} else {
if (age <= allowedAge) {
continue;
}
}
}
if (filterModel.year) {
if (filterModel.year.values.indexOf(item.year.toString()) < 0) {
// year didn't match, so skip this record
continue;
}
}
if (filterModel.country) {
if (filterModel.country.values.indexOf(item.country) < 0) {
continue;
}
}
resultOfFilter.push(item);
}
return resultOfFilter;
}
export function getCountries() {
return [
'United States',
'Russia',
'Australia',
'Canada',
'Norway',
'China',
'Zimbabwe',
'Netherlands',
'South Korea',
'Croatia',
'France',
'Japan',
'Hungary',
'Germany',
'Poland',
'South Africa',
'Sweden',
'Ukraine',
'Italy',
'Czech Republic',
'Austria',
'Finland',
'Romania',
'Great Britain',
'Jamaica',
'Singapore',
'Belarus',
'Chile',
'Spain',
'Tunisia',
'Brazil',
'Slovakia',
'Costa Rica',
'Bulgaria',
'Switzerland',
'New Zealand',
'Estonia',
'Kenya',
'Ethiopia',
'Trinidad and Tobago',
'Turkey',
'Morocco',
'Bahamas',
'Slovenia',
'Armenia',
'Azerbaijan',
'India',
'Puerto Rico',
'Egypt',
'Kazakhstan',
'Iran',
'Georgia',
'Lithuania',
'Cuba',
'Colombia',
'Mongolia',
'Uzbekistan',
'North Korea',
'Tajikistan',
'Kyrgyzstan',
'Greece',
'Macedonia',
'Moldova',
'Chinese Taipei',
'Indonesia',
'Thailand',
'Vietnam',
'Latvia',
'Venezuela',
'Mexico',
'Nigeria',
'Qatar',
'Serbia',
'Serbia and Montenegro',
'Hong Kong',
'Denmark',
'Portugal',
'Argentina',
'Afghanistan',
'Gabon',
'Dominican Republic',
'Belgium',
'Kuwait',
'United Arab Emirates',
'Cyprus',
'Israel',
'Algeria',
'Montenegro',
'Iceland',
'Paraguay',
'Cameroon',
'Saudi Arabia',
'Ireland',
'Malaysia',
'Uruguay',
'Togo',
'Mauritius',
'Syria',
'Botswana',
'Guatemala',
'Bahrain',
'Grenada',
'Uganda',
'Sudan',
'Ecuador',
'Panama',
'Eritrea',
'Sri Lanka',
'Mozambique',
'Barbados',
];
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} When performing multiple row selections using shift-click, it is possible that not all rows are available in memory if the configured value of maxBlocksInCache doesn't cover the range. In this case multiple selections will not be allowed.
Specify Selectable Rows Copy Link
It is also possible to specify which rows can be selected via the rowSelection.isRowSelectable callback function.
Callback to be used to determine which rows are selectable. By default rows are selectable, so return false to make a row non-selectable.
|
For instance if we only wanted to allow rows where the data.country property is the 'United States' we could implement the following:
<ag-grid-angular
[rowSelection]="rowSelection"
/* other grid options ... */ />
this.rowSelection = {
mode: 'multiRow',
isRowSelectable: function(data) {
return data.country === 'United States';
}
};import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ICellRendererParams,
IDatasource,
IGetRowsParams,
IRowNode,
InfiniteRowModelModule,
ModuleRegistry,
RowModelType,
RowSelectionModule,
RowSelectionOptions,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([RowSelectionModule, InfiniteRowModelModule]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowBuffer]="rowBuffer"
[rowSelection]="rowSelection"
[rowModelType]="rowModelType"
[cacheBlockSize]="cacheBlockSize"
[cacheOverflowSize]="cacheOverflowSize"
[maxConcurrentDatasourceRequests]="maxConcurrentDatasourceRequests"
[infiniteInitialRowCount]="infiniteInitialRowCount"
[maxBlocksInCache]="maxBlocksInCache"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
// this row shows the row index, doesn't use any data from the row
{
headerName: "ID",
maxWidth: 100,
// it is important to have node.id here, so that when the id changes (which happens
// when the row is loaded) then the cell is refreshed.
valueGetter: "node.id",
cellRenderer: (params: ICellRendererParams) => {
if (params.value !== undefined) {
return params.value;
} else {
return '<img src="https://www.ag-grid.com/example-assets/loading.gif">';
}
},
},
{ field: "athlete", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 200 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 100,
sortable: false,
};
rowBuffer = 0;
rowSelection: RowSelectionOptions | "single" | "multiple" = {
mode: "multiRow",
hideDisabledCheckboxes: true,
headerCheckbox: false,
isRowSelectable: (rowNode: IRowNode) => {
return rowNode.data ? rowNode.data.country === "United States" : false;
},
};
rowModelType: RowModelType = "infinite";
cacheBlockSize = 100;
cacheOverflowSize = 2;
maxConcurrentDatasourceRequests = 2;
infiniteInitialRowCount = 1;
maxBlocksInCache = 2;
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => {
const dataSource: IDatasource = {
rowCount: undefined, // behave as infinite scroll
getRows: (params: IGetRowsParams) => {
// console.log('asking for ' + params.startRow + ' to ' + params.endRow);
// At this point in your code, you would call the server.
// To make the demo look real, wait for 500ms before returning
setTimeout(() => {
// take a slice of the total rows
const rowsThisPage = data.slice(params.startRow, params.endRow);
// if on or after the last page, work out the last row.
let lastRow = -1;
if (data.length <= params.endRow) {
lastRow = data.length;
}
// call the success callback
params.successCallback(rowsThisPage, lastRow);
}, 500);
},
};
params.api!.setGridOption("datasource", dataSource);
});
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Note that in the above example we have hidden disabled checkboxes to help highlight which rows are selectable.
Configuring a Bit Differently Copy Link
The examples above use old-style JavaScript objects for the datasource. This example turns things around slightly and creates a datasource Class. The example also just generates data on the fly.
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import {
ColDef,
ColGroupDef,
ColumnApiModule,
GetRowIdFunc,
GetRowIdParams,
GridApi,
GridOptions,
GridReadyEvent,
IDatasource,
IGetRowsParams,
InfiniteRowModelModule,
ModuleRegistry,
RowModelType,
RowSelectionModule,
RowSelectionOptions,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ColumnApiModule,
RowSelectionModule,
InfiniteRowModelModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[rowModelType]="rowModelType"
[rowSelection]="rowSelection"
[maxBlocksInCache]="maxBlocksInCache"
[getRowId]="getRowId"
[datasource]="datasource"
[defaultColDef]="defaultColDef"
[rowData]="rowData"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = getColumnDefs();
rowModelType: RowModelType = "infinite";
rowSelection: RowSelectionOptions | "single" | "multiple" = {
mode: "multiRow",
headerCheckbox: false,
};
maxBlocksInCache = 2;
getRowId: GetRowIdFunc = (params: GetRowIdParams) => {
return params.data.a;
};
datasource: IDatasource = getDataSource(100);
defaultColDef: ColDef = {
sortable: false,
};
rowData!: any[];
}
const ALPHABET = "abcdefghijklmnopqrstuvwxyz".split("");
function getColumnDefs() {
const columnDefs: ColDef[] = [
{ headerName: "#", width: 80, valueGetter: "node.rowIndex" },
];
ALPHABET.forEach((letter) => {
columnDefs.push({
headerName: letter.toUpperCase(),
field: letter,
width: 150,
});
});
return columnDefs;
}
function getDataSource(count: number) {
const dataSource: IDatasource = {
rowCount: count,
getRows: (params: IGetRowsParams) => {
const rowsThisPage: any[] = [];
for (
var rowIndex = params.startRow;
rowIndex < params.endRow;
rowIndex++
) {
var record: Record<string, string> = {};
ALPHABET.forEach(function (letter, colIndex) {
const randomNumber = 17 + rowIndex + colIndex;
const cellKey = letter.toUpperCase() + (rowIndex + 1);
record[letter] = cellKey + " = " + randomNumber;
});
rowsThisPage.push(record);
}
// to mimic server call, we reply after a short delay
setTimeout(() => {
// no need to pass the second 'rowCount' parameter as we have already provided it
params.successCallback(rowsThisPage);
}, 100);
},
};
return dataSource;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
Loading Spinner Copy Link
The examples on this page use a loading spinner to show if the row is waiting for its data to be loaded. The grid does not provide this, rather it is a simple rendering technique used in the examples. If the data is loading, then the rowNode will have no ID, so if you use the ID as the value, the cell will get refreshed when the ID is set.
loadingSpinnerColumn = {
// use a value getter to have the node ID as this column's value
valueGetter: 'node.id',
// then a custom cellRenderer
cellRenderer: function(params) {
if (params.value === undefined) {
// when no node id, display the spinner image
return '<img src="loading.gif" />';
} else {
// otherwise just display node ID (or whatever you wish for this column)
return params.value;
}
}
}Refer to section Cell Rendering for how to build cell renderers.
More Control via Properties and API Copy Link
Infinite scrolling has a cache working behind the scenes. The following properties and API are provided to give you control of the cache.
Properties Copy Link
How many extra blank rows to display to the user at the end of the dataset, which sets the vertical scroll and then allows the grid to request viewing more rows of data. |
How many requests to hit the server with concurrently. If the max is reached, requests are queued.
Set to -1 for no maximum restriction on requests. |
How many rows for each block in the store, i.e. how many rows returned from the server at a time. |
How many blocks to keep in the store. Default is no limit, so every requested block is kept. Use this if you have memory concerns, and blocks that were least recently viewed will be purged when the limit is hit. The grid will additionally make sure it has all the blocks needed to display what is currently visible, in case this property is set to a low value. |
How many extra blank rows to display to the user at the end of the dataset, which sets the vertical scroll and then allows the grid to request viewing more rows of data. |
API Copy Link
Marks all the currently loaded blocks in the cache for reload.
If you have 10 blocks in the cache, all 10 will be marked for reload.
The old data will continue to be displayed until the new data is loaded. |
Purges the cache.
The grid is then told to refresh. Only the blocks required to display the current data on screen are fetched (typically no more than 2).
The grid will display nothing while the new blocks are loaded.
Use this to immediately remove the old data from the user. |
Returns false if grid allows for scrolling past the last row to load more rows, thus providing infinite scroll. |
Sets the rowCount and maxRowFound properties.
The second parameter, maxRowFound, is optional and if left out, only rowCount is set.
Set rowCount to adjust the height of the vertical scroll.
Set maxRowFound to enable / disable searching for more rows.
Use this method if you add or remove rows into the dataset and need to reset the number of rows or instruct the grid that the entire row count is no longer known. |
Returns an object representing the state of the cache. This is useful for debugging and understanding how the cache is working. |
Adding / removing rows directly in the grid for infinite scrolling is not recommended as it will complicate your application. It will make your life easier if you update the data on the server and refresh the block cache.
Example: Using Cache API Methods Copy Link
Below demonstrates the different API methods via the buttons. The example outputs a lot of debugging items to the console because the grid property debug=true is set. The buttons are as follows:
- Insert Rows: Inserts 5 rows at row index 2 from the server, then refreshes the grid.
- Delete Rows: Deletes 10 rows at row index 3 from the server, then refreshes the grid.
- Set Row Count: Sets the row count to 200. This adjusts the vertical scroll to show 200 rows. If the scroll is positioned at the end, this results in the grid automatically re-adjusting as it seeks ahead for the next block of data.
- Print Info: Prints
rowCountandmaxFoundto the console. - Jump to 500: Positions the grid so that row 500 is displayed.
- Print Cache State: Debugging method, to see the state of the cache.
- Set Prices High & Set Prices Low: Sets the prices on the server-side to either high or low prices. This will not impact the grid until after a block cache is loaded. Use these buttons to then further test the refresh and purge methods.
- Refresh Cache: Calls for the cache to be refreshed.
- Purge Cache: Calls for the cache to be purged.
The example also makes each Honda row bold - demonstrating that the callbacks getRowStyle and getRowClass get called after the data is set as well as when the row is created (when the data may not yet be available).
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import {
ColDef,
ColGroupDef,
GetRowIdFunc,
GetRowIdParams,
GetRowStyle,
GridApi,
GridOptions,
GridReadyEvent,
ICellRendererParams,
IDatasource,
IGetRowsParams,
InfiniteRowModelModule,
ModuleRegistry,
RowApiModule,
RowClassParams,
RowModelType,
RowStyle,
RowStyleModule,
ScrollApiModule,
ValueFormatterParams,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
RowApiModule,
ScrollApiModule,
RowStyleModule,
InfiniteRowModelModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<div style="display: flex; flex-direction: column; height: 100%">
<div style="margin-bottom: 10px">
<button (click)="insertItemsAt2AndRefresh(5)">Insert Rows</button>
<button (click)="removeItem(3, 10)">Delete Rows</button>
<button (click)="setRowCountTo200()">Set Row Count</button>
<button (click)="rowsAndMaxFound()">Print Info</button>
<button (click)="jumpTo500()">Jump to 500</button>
</div>
<div style="margin-bottom: 10px">
<button (click)="setPricesHigh()">Set Prices High</button>
<button (click)="setPricesLow()">Set Prices Low</button>
<button (click)="refreshCache()">Refresh Cache</button>
<button (click)="purgeCache()">Purge Cache</button>
</div>
<div style="flex-grow: 1">
<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[datasource]="datasource"
[defaultColDef]="defaultColDef"
[rowModelType]="rowModelType"
[maxBlocksInCache]="maxBlocksInCache"
[infiniteInitialRowCount]="infiniteInitialRowCount"
[maxConcurrentDatasourceRequests]="maxConcurrentDatasourceRequests"
[getRowId]="getRowId"
[getRowStyle]="getRowStyle"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/>
</div>
</div> `,
})
export class AppComponent {
private gridApi!: GridApi;
columnDefs: ColDef[] = [
{
headerName: "Item ID",
field: "id",
valueGetter: "node.id",
cellRenderer: (params: ICellRendererParams) => {
if (params.value !== undefined) {
return params.value;
} else {
return '<img src="https://www.ag-grid.com/example-assets/loading.gif">';
}
},
},
{ field: "make" },
{ field: "model" },
{
field: "price",
valueFormatter: valueFormatter,
},
];
datasource: IDatasource = {
rowCount: undefined, // behave as infinite scroll
getRows: (params: IGetRowsParams) => {
console.log("asking for " + params.startRow + " to " + params.endRow);
// At this point in your code, you would call the server.
// To make the demo look real, wait for 500ms before returning
setTimeout(() => {
// take a slice of the total rows
const rowsThisPage = allOfTheData.slice(params.startRow, params.endRow);
// make a copy of each row - this is what would happen if taking data from server
for (let i = 0; i < rowsThisPage.length; i++) {
const item = rowsThisPage[i];
// this is a trick to copy an object
const itemCopy = JSON.parse(JSON.stringify(item));
rowsThisPage[i] = itemCopy;
}
// if on or after the last page, work out the last row.
let lastRow = -1;
if (allOfTheData.length <= params.endRow) {
lastRow = allOfTheData.length;
}
// call the success callback
params.successCallback(rowsThisPage, lastRow);
}, 500);
},
};
defaultColDef: ColDef = {
flex: 1,
sortable: false,
};
rowModelType: RowModelType = "infinite";
maxBlocksInCache = 2;
infiniteInitialRowCount = 500;
maxConcurrentDatasourceRequests = 2;
getRowId: GetRowIdFunc = (params: GetRowIdParams) => {
return params.data.id.toString();
};
getRowStyle: GetRowStyle = (params: RowClassParams): RowStyle | undefined => {
if (params.data && params.data.make === "Honda") {
return {
fontWeight: "bold",
};
}
return {
fontWeight: "normal",
};
};
rowData!: any[];
insertItemsAt2AndRefresh(count: number) {
insertItemsAt2(count);
// if the data has stopped looking for the last row, then we need to adjust the
// row count to allow for the extra data, otherwise the grid will not allow scrolling
// to the last row. eg if we have 1000 rows, scroll all the way to the bottom (so
// maxRowFound=true), and then add 5 rows, the rowCount needs to be adjusted
// to 1005, so grid can scroll to the end. the grid does NOT do this for you in the
// refreshInfiniteCache() method, as this would be assuming you want to do it which
// is not true, maybe the row count is constant and you just want to refresh the details.
const maxRowFound = this.gridApi.isLastRowIndexKnown();
if (maxRowFound) {
const rowCount = this.gridApi.getDisplayedRowCount() || 0;
this.gridApi.setRowCount(rowCount + count);
}
// get grid to refresh the data
this.gridApi.refreshInfiniteCache();
}
removeItem(start: number, limit: number) {
allOfTheData.splice(start, limit);
this.gridApi.refreshInfiniteCache();
}
refreshCache() {
this.gridApi.refreshInfiniteCache();
}
purgeCache() {
this.gridApi.purgeInfiniteCache();
}
setRowCountTo200() {
this.gridApi.setRowCount(200, false);
}
rowsAndMaxFound() {
console.log(
"getDisplayedRowCount() => " + this.gridApi.getDisplayedRowCount(),
);
console.log(
"isLastRowIndexKnown() => " + this.gridApi.isLastRowIndexKnown(),
);
}
// function just gives new prices to the row data, it does not update the grid
setPricesHigh() {
allOfTheData.forEach((dataItem) => {
dataItem.price = Math.round(55500 + 400 * (0.5 + window.agRandom()));
});
}
setPricesLow() {
allOfTheData.forEach((dataItem) => {
dataItem.price = Math.round(1000 + 100 * (0.5 + window.agRandom()));
});
}
jumpTo500() {
// first up, need to make sure the grid is actually showing 500 or more rows
if ((this.gridApi.getDisplayedRowCount() || 0) < 501) {
this.gridApi.setRowCount(501, false);
}
// next, we can jump to the row
this.gridApi.ensureIndexVisible(500);
}
onGridReady(params: GridReadyEvent) {
this.gridApi = params.api;
sequenceId = 1;
allOfTheData = [];
for (let i = 0; i < 1000; i++) {
allOfTheData.push(createRowData(sequenceId++));
}
}
}
const valueFormatter = function (params: ValueFormatterParams) {
if (typeof params.value === "number") {
return "£" + params.value.toLocaleString();
} else {
return params.value;
}
};
// this counter is used to give id's to the rows
var sequenceId = 0;
var allOfTheData: any[] = [];
function createRowData(id: number) {
const makes = ["Toyota", "Ford", "Porsche", "Chevy", "Honda", "Nissan"];
const models = [
"Cruze",
"Celica",
"Mondeo",
"Boxster",
"Genesis",
"Accord",
"Taurus",
];
return {
id: id,
make: makes[id % makes.length],
model: models[id % models.length],
price: 72000,
};
}
function insertItemsAt2(count: number) {
const newDataItems = [];
for (let i = 0; i < count; i++) {
const newItem = createRowData(sequenceId++);
allOfTheData.splice(2, 0, newItem);
newDataItems.push(newItem);
}
return newDataItems;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
Changing Columns Copy Link
Changing columns is possible using infinite scroll and it does not require the data getting fetched again from the server. If the change of columns impacts the sort or filter (i.e. a column with a sort or filter applied is removed), the grid will fetch data again similar to how data is fetched again after the user changes the sort or filter explicitly.
The example below demonstrates changing columns on the infinite row model. The following can be noted:
- Hit the buttons 'Show Year' and 'Hide Year'. Notice that the data is not re-fetched.
- Add a sort or filter to Age column. When the sort or filter is applied the data is re-fetched. However once fetched, you can add and remove the Year column without re-fetching the data.
- Add a sort or filter to the Year column. When the sort or filter is applied the data is re-fetched. Now remove the Year column and the data is re-fetched again as the sort or filter has changed.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./style.css";
import {
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
IDatasource,
InfiniteRowModelModule,
ModuleRegistry,
RowModelType,
SortModelItem,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([TextFilterModule, InfiniteRowModelModule]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<div class="test-container">
<div class="test-header">
<button (click)="onBtShowYearColumn()">Show Year</button>
<button (click)="onBtHideYearColumn()">Hide Year</button>
</div>
<ag-grid-angular
style="width: 100%; height: 100%;"
class="test-grid"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowModelType]="rowModelType"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/>
</div> `,
})
export class AppComponent {
private gridApi!: GridApi<IOlympicData>;
columnDefs: ColDef[] = [
{ field: "athlete", colId: "athlete", minWidth: 180 },
{ field: "age", colId: "age" },
{ field: "country", colId: "country", minWidth: 180 },
{ field: "year", colId: "year" },
{ field: "sport", colId: "sport", minWidth: 180 },
];
defaultColDef: ColDef = {
flex: 1,
filter: true,
};
rowModelType: RowModelType = "infinite";
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onBtShowYearColumn() {
this.gridApi.setGridOption("columnDefs", [
{ field: "athlete", colId: "athlete" },
{ field: "age", colId: "age" },
{ field: "country", colId: "country" },
{ field: "year", colId: "year" },
{ field: "sport", colId: "sport" },
]);
}
onBtHideYearColumn() {
this.gridApi.setGridOption("columnDefs", [
{ field: "athlete", colId: "athlete" },
{ field: "age", colId: "age" },
{ field: "country", colId: "country" },
{ field: "sport", colId: "sport" },
]);
}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.gridApi = params.api;
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => {
// give each row an id
data.forEach(function (d: any, index: number) {
d.id = "R" + (index + 1);
});
const dataSource: IDatasource = {
rowCount: undefined, // behave as infinite scroll
getRows: (params) => {
console.log(
"asking for " + params.startRow + " to " + params.endRow,
);
// At this point in your code, you would call the server.
// To make the demo look real, wait for 500ms before returning
setTimeout(() => {
// take a slice of the total rows
const dataAfterSortingAndFiltering = sortAndFilter(
data,
params.sortModel,
params.filterModel,
);
const rowsThisPage = dataAfterSortingAndFiltering.slice(
params.startRow,
params.endRow,
);
// if on or after the last page, work out the last row.
let lastRow = -1;
if (dataAfterSortingAndFiltering.length <= params.endRow) {
lastRow = dataAfterSortingAndFiltering.length;
}
// call the success callback
params.successCallback(rowsThisPage, lastRow);
}, 500);
},
};
params.api!.setGridOption("datasource", dataSource);
});
}
}
function sortAndFilter(
allOfTheData: any[],
sortModel: SortModelItem[],
filterModel: any,
) {
return sortData(sortModel, filterData(filterModel, allOfTheData));
}
function sortData(sortModel: SortModelItem[], data: any[]) {
const sortPresent = sortModel && sortModel.length > 0;
if (!sortPresent) {
return data;
}
// do an in memory sort of the data, across all the fields
const resultOfSort = data.slice();
resultOfSort.sort(function (a, b) {
for (let k = 0; k < sortModel.length; k++) {
const sortColModel = sortModel[k];
const valueA = a[sortColModel.colId];
const valueB = b[sortColModel.colId];
// this filter didn't find a difference, move onto the next one
if (valueA == valueB) {
continue;
}
const sortDirection = sortColModel.sort === "asc" ? 1 : -1;
if (valueA > valueB) {
return sortDirection;
} else {
return sortDirection * -1;
}
}
// no filters found a difference
return 0;
});
return resultOfSort;
}
function filterData(filterModel: any, data: any[]) {
const filterPresent = filterModel && Object.keys(filterModel).length > 0;
if (!filterPresent) {
return data;
}
const resultOfFilter = [];
for (let i = 0; i < data.length; i++) {
var item = data[i];
var filterFails = false;
const filterKeys = Object.keys(filterModel);
filterKeys.forEach((filterKey) => {
const filterValue = filterModel[filterKey].filter;
const valueForRow = item[filterKey];
if (filterValue != valueForRow) {
// year didn't match, so skip this record
filterFails = true;
}
});
// if (filterModel.year) {
// var val1 = filterModel.year.filter;
// var val2 = item.year;
// if (val1 != val2) {
// // year didn't match, so skip this record
// continue;
// }
// }
//
if (!filterFails) {
resultOfFilter.push(item);
}
}
return resultOfFilter;
}
.test-grid {
height: 1px;
min-height: 1px;
flex-grow: 1;
}
.test-container {
height: 100%;
display: flex;
flex-direction: column;
}
.test-header {
margin-bottom: 5px;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Pagination Copy Link
As with all row models, it is possible to enable pagination with infinite scrolling. With infinite scrolling, it is possible to mix and match with the configuration to achieve different effects. The following examples are presented:
| Example | Page Size | Block Size | Comment |
|---|---|---|---|
| Example 1 | Auto | Large | Most Recommended |
| Example 2 | Equal | Equal | Recommended Sometimes |
Having smaller infinite blocks size than your pagination page size is not supported
You must have infinite block size greater than or equal to the pagination page size. If you have a smaller block size, the grid will not fetch enough rows to display one page. This breaks how infinite scrolling works and is not supported.
Example 1: Auto Pagination Page Size, Large Infinite Block Size Copy Link
This example is the recommended approach. The infinite block size is larger than the pages size, so the grid loads data for a few pages, allowing the user to hit 'next' a few times before a server sided call is needed.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
ColDef,
ColGroupDef,
GetRowIdFunc,
GetRowIdParams,
GridApi,
GridOptions,
GridReadyEvent,
ICellRendererParams,
IDatasource,
IGetRowsParams,
InfiniteRowModelModule,
ModuleRegistry,
NumberFilterModule,
PaginationModule,
RowModelType,
SortModelItem,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { countries } from "./countries";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
PaginationModule,
ColumnsToolPanelModule,
InfiniteRowModelModule,
ColumnMenuModule,
ContextMenuModule,
SetFilterModule,
NumberFilterModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowModelType]="rowModelType"
[cacheBlockSize]="cacheBlockSize"
[cacheOverflowSize]="cacheOverflowSize"
[maxConcurrentDatasourceRequests]="maxConcurrentDatasourceRequests"
[infiniteInitialRowCount]="infiniteInitialRowCount"
[maxBlocksInCache]="maxBlocksInCache"
[pagination]="true"
[paginationAutoPageSize]="true"
[getRowId]="getRowId"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
// this row just shows the row index, doesn't use any data from the row
{
headerName: "ID",
maxWidth: 100,
valueGetter: "node.id",
cellRenderer: (params: ICellRendererParams) => {
if (params.value !== undefined) {
return params.value;
} else {
return '<img src="https://www.ag-grid.com/example-assets/loading.gif">';
}
},
// we don't want to sort by the row index, this doesn't make sense as the point
// of the row index is to know the row index in what came back from the server
sortable: false,
suppressHeaderMenuButton: true,
},
{ headerName: "Athlete", field: "athlete", suppressHeaderMenuButton: true },
{
field: "age",
filter: "agNumberColumnFilter",
filterParams: {
filterOptions: ["equals", "lessThan", "greaterThan"],
},
},
{
field: "country",
filter: "agSetColumnFilter",
filterParams: filterParams,
},
{
field: "year",
filter: "agSetColumnFilter",
filterParams: { values: ["2000", "2004", "2008", "2012"] },
},
{ field: "date" },
{ field: "sport", suppressHeaderMenuButton: true },
{ field: "gold", suppressHeaderMenuButton: true },
{ field: "silver", suppressHeaderMenuButton: true },
{ field: "bronze", suppressHeaderMenuButton: true },
{ field: "total", suppressHeaderMenuButton: true },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 150,
floatingFilter: true,
};
rowModelType: RowModelType = "infinite";
cacheBlockSize = 100;
cacheOverflowSize = 2;
maxConcurrentDatasourceRequests = 2;
infiniteInitialRowCount = 1;
maxBlocksInCache = 2;
getRowId: GetRowIdFunc = (params: GetRowIdParams) => {
return params.data.id;
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => {
data.forEach(function (d: any, index: number) {
d.id = "R" + (index + 1);
});
const dataSource: IDatasource = {
rowCount: undefined, // behave as infinite scroll
getRows: (params: IGetRowsParams) => {
console.log(
"asking for " + params.startRow + " to " + params.endRow,
);
// At this point in your code, you would call the server.
// To make the demo look real, wait for 500ms before returning
setTimeout(() => {
// take a slice of the total rows
const dataAfterSortingAndFiltering = sortAndFilter(
data,
params.sortModel,
params.filterModel,
);
const rowsThisPage = dataAfterSortingAndFiltering.slice(
params.startRow,
params.endRow,
);
// if on or after the last page, work out the last row.
let lastRow = -1;
if (dataAfterSortingAndFiltering.length <= params.endRow) {
lastRow = dataAfterSortingAndFiltering.length;
}
// call the success callback
params.successCallback(rowsThisPage, lastRow);
}, 500);
},
};
params.api!.setGridOption("datasource", dataSource);
});
}
}
const filterParams = { values: countries() };
function sortAndFilter(
allOfTheData: any[],
sortModel: SortModelItem[],
filterModel: any,
) {
return sortData(sortModel, filterData(filterModel, allOfTheData));
}
function sortData(sortModel: SortModelItem[], data: any[]) {
const sortPresent = sortModel && sortModel.length > 0;
if (!sortPresent) {
return data;
}
// do an in memory sort of the data, across all the fields
const resultOfSort = data.slice();
resultOfSort.sort(function (a, b) {
for (let k = 0; k < sortModel.length; k++) {
const sortColModel = sortModel[k];
const valueA = a[sortColModel.colId];
const valueB = b[sortColModel.colId];
// this filter didn't find a difference, move onto the next one
if (valueA == valueB) {
continue;
}
const sortDirection = sortColModel.sort === "asc" ? 1 : -1;
if (valueA > valueB) {
return sortDirection;
} else {
return sortDirection * -1;
}
}
// no filters found a difference
return 0;
});
return resultOfSort;
}
function filterData(filterModel: any, data: any[]) {
const filterPresent = filterModel && Object.keys(filterModel).length > 0;
if (!filterPresent) {
return data;
}
const resultOfFilter = [];
for (let i = 0; i < data.length; i++) {
const item = data[i];
if (filterModel.age) {
const age = item.age;
const allowedAge = parseInt(filterModel.age.filter);
// EQUALS = 1;
// LESS_THAN = 2;
// GREATER_THAN = 3;
if (filterModel.age.type == "equals") {
if (age !== allowedAge) {
continue;
}
} else if (filterModel.age.type == "lessThan") {
if (age >= allowedAge) {
continue;
}
} else {
if (age <= allowedAge) {
continue;
}
}
}
if (filterModel.year) {
if (filterModel.year.values.indexOf(item.year.toString()) < 0) {
// year didn't match, so skip this record
continue;
}
}
if (filterModel.country) {
if (filterModel.country.values.indexOf(item.country) < 0) {
continue;
}
}
resultOfFilter.push(item);
}
return resultOfFilter;
}
export function countries() {
return [
'United States',
'Russia',
'Australia',
'Canada',
'Norway',
'China',
'Zimbabwe',
'Netherlands',
'South Korea',
'Croatia',
'France',
'Japan',
'Hungary',
'Germany',
'Poland',
'South Africa',
'Sweden',
'Ukraine',
'Italy',
'Czech Republic',
'Austria',
'Finland',
'Romania',
'Great Britain',
'Jamaica',
'Singapore',
'Belarus',
'Chile',
'Spain',
'Tunisia',
'Brazil',
'Slovakia',
'Costa Rica',
'Bulgaria',
'Switzerland',
'New Zealand',
'Estonia',
'Kenya',
'Ethiopia',
'Trinidad and Tobago',
'Turkey',
'Morocco',
'Bahamas',
'Slovenia',
'Armenia',
'Azerbaijan',
'India',
'Puerto Rico',
'Egypt',
'Kazakhstan',
'Iran',
'Georgia',
'Lithuania',
'Cuba',
'Colombia',
'Mongolia',
'Uzbekistan',
'North Korea',
'Tajikistan',
'Kyrgyzstan',
'Greece',
'Macedonia',
'Moldova',
'Chinese Taipei',
'Indonesia',
'Thailand',
'Vietnam',
'Latvia',
'Venezuela',
'Mexico',
'Nigeria',
'Qatar',
'Serbia',
'Serbia and Montenegro',
'Hong Kong',
'Denmark',
'Portugal',
'Argentina',
'Afghanistan',
'Gabon',
'Dominican Republic',
'Belgium',
'Kuwait',
'United Arab Emirates',
'Cyprus',
'Israel',
'Algeria',
'Montenegro',
'Iceland',
'Paraguay',
'Cameroon',
'Saudi Arabia',
'Ireland',
'Malaysia',
'Uruguay',
'Togo',
'Mauritius',
'Syria',
'Botswana',
'Guatemala',
'Bahrain',
'Grenada',
'Uganda',
'Sudan',
'Ecuador',
'Panama',
'Eritrea',
'Sri Lanka',
'Mozambique',
'Barbados',
];
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Example 2: Equal Pagination Page Size and Large Infinite Block Size Copy Link
This example demonstrates having the page and block sizes equal. Here the server is hit every time a new page is navigated to.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
ColDef,
ColGroupDef,
GetRowIdFunc,
GetRowIdParams,
GridApi,
GridOptions,
GridReadyEvent,
ICellRendererParams,
IDatasource,
IGetRowsParams,
InfiniteRowModelModule,
ModuleRegistry,
NumberFilterModule,
PaginationModule,
RowModelType,
SortModelItem,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { countries } from "./countries";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
PaginationModule,
ColumnsToolPanelModule,
InfiniteRowModelModule,
ColumnMenuModule,
ContextMenuModule,
SetFilterModule,
NumberFilterModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowModelType]="rowModelType"
[cacheOverflowSize]="cacheOverflowSize"
[maxConcurrentDatasourceRequests]="maxConcurrentDatasourceRequests"
[infiniteInitialRowCount]="infiniteInitialRowCount"
[maxBlocksInCache]="maxBlocksInCache"
[pagination]="true"
[getRowId]="getRowId"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
// this row just shows the row index, doesn't use any data from the row
{
headerName: "ID",
maxWidth: 100,
valueGetter: "node.id",
cellRenderer: (params: ICellRendererParams) => {
if (params.value !== undefined) {
return params.value;
} else {
return '<img src="https://www.ag-grid.com/example-assets/loading.gif">';
}
},
// we don't want to sort by the row index, this doesn't make sense as the point
// of the row index is to know the row index in what came back from the server
sortable: false,
suppressHeaderMenuButton: true,
},
{
headerName: "Athlete",
field: "athlete",
width: 150,
suppressHeaderMenuButton: true,
},
{
field: "age",
filter: "agNumberColumnFilter",
filterParams: {
filterOptions: ["equals", "lessThan", "greaterThan"],
},
},
{
field: "country",
filter: "agSetColumnFilter",
filterParams: filterParams,
},
{
field: "year",
filter: "agSetColumnFilter",
filterParams: { values: ["2000", "2004", "2008", "2012"] },
},
{ field: "date" },
{ field: "sport", suppressHeaderMenuButton: true },
{ field: "gold", suppressHeaderMenuButton: true },
{ field: "silver", suppressHeaderMenuButton: true },
{ field: "bronze", suppressHeaderMenuButton: true },
{ field: "total", suppressHeaderMenuButton: true },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 150,
floatingFilter: true,
};
rowModelType: RowModelType = "infinite";
cacheOverflowSize = 2;
maxConcurrentDatasourceRequests = 2;
infiniteInitialRowCount = 1;
maxBlocksInCache = 2;
getRowId: GetRowIdFunc = (params: GetRowIdParams) => {
return params.data.id;
};
rowData!: any[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent) {
this.http
.get<any[]>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => {
// give each row an id
data.forEach(function (x: any, index: number) {
x.id = "R" + (index + 1);
});
const dataSource: IDatasource = {
rowCount: undefined, // behave as infinite scroll
getRows: (params: IGetRowsParams) => {
console.log(
"asking for " + params.startRow + " to " + params.endRow,
);
// At this point in your code, you would call the server
// To make the demo look real, wait for 500ms before returning
setTimeout(() => {
// take a slice of the total rows
const dataAfterSortingAndFiltering = sortAndFilter(
data,
params.sortModel,
params.filterModel,
);
const rowsThisPage = dataAfterSortingAndFiltering.slice(
params.startRow,
params.endRow,
);
// if on or after the last page, work out the last row.
let lastRow = -1;
if (dataAfterSortingAndFiltering.length <= params.endRow) {
lastRow = dataAfterSortingAndFiltering.length;
}
// call the success callback
params.successCallback(rowsThisPage, lastRow);
}, 500);
},
};
params.api!.setGridOption("datasource", dataSource);
});
}
}
const filterParams = { values: countries() };
function sortAndFilter(
allOfTheData: any[],
sortModel: SortModelItem[],
filterModel: any,
) {
return sortData(sortModel, filterData(filterModel, allOfTheData));
}
function sortData(sortModel: SortModelItem[], data: any[]) {
const sortPresent = sortModel && sortModel.length > 0;
if (!sortPresent) {
return data;
}
// do an in memory sort of the data, across all the fields
const resultOfSort = data.slice();
resultOfSort.sort(function (a, b) {
for (let k = 0; k < sortModel.length; k++) {
const sortColModel = sortModel[k];
const valueA = a[sortColModel.colId];
const valueB = b[sortColModel.colId];
// this filter didn't find a difference, move onto the next one
if (valueA == valueB) {
continue;
}
const sortDirection = sortColModel.sort === "asc" ? 1 : -1;
if (valueA > valueB) {
return sortDirection;
} else {
return sortDirection * -1;
}
}
// no filters found a difference
return 0;
});
return resultOfSort;
}
function filterData(filterModel: any, data: any[]) {
const filterPresent = filterModel && Object.keys(filterModel).length > 0;
if (!filterPresent) {
return data;
}
const resultOfFilter = [];
for (let i = 0; i < data.length; i++) {
const item = data[i];
if (filterModel.age) {
const age = item.age;
const allowedAge = parseInt(filterModel.age.filter);
// EQUALS = 1;
// LESS_THAN = 2;
// GREATER_THAN = 3;
if (filterModel.age.type == "equals") {
if (age !== allowedAge) {
continue;
}
} else if (filterModel.age.type == "lessThan") {
if (age >= allowedAge) {
continue;
}
} else {
if (age <= allowedAge) {
continue;
}
}
}
if (filterModel.year) {
if (filterModel.year.values.indexOf(item.year.toString()) < 0) {
// year didn't match, so skip this record
continue;
}
}
if (filterModel.country) {
if (filterModel.country.values.indexOf(item.country) < 0) {
continue;
}
}
resultOfFilter.push(item);
}
return resultOfFilter;
}
export function countries() {
return [
'United States',
'Russia',
'Australia',
'Canada',
'Norway',
'China',
'Zimbabwe',
'Netherlands',
'South Korea',
'Croatia',
'France',
'Japan',
'Hungary',
'Germany',
'Poland',
'South Africa',
'Sweden',
'Ukraine',
'Italy',
'Czech Republic',
'Austria',
'Finland',
'Romania',
'Great Britain',
'Jamaica',
'Singapore',
'Belarus',
'Chile',
'Spain',
'Tunisia',
'Brazil',
'Slovakia',
'Costa Rica',
'Bulgaria',
'Switzerland',
'New Zealand',
'Estonia',
'Kenya',
'Ethiopia',
'Trinidad and Tobago',
'Turkey',
'Morocco',
'Bahamas',
'Slovenia',
'Armenia',
'Azerbaijan',
'India',
'Puerto Rico',
'Egypt',
'Kazakhstan',
'Iran',
'Georgia',
'Lithuania',
'Cuba',
'Colombia',
'Mongolia',
'Uzbekistan',
'North Korea',
'Tajikistan',
'Kyrgyzstan',
'Greece',
'Macedonia',
'Moldova',
'Chinese Taipei',
'Indonesia',
'Thailand',
'Vietnam',
'Latvia',
'Venezuela',
'Mexico',
'Nigeria',
'Qatar',
'Serbia',
'Serbia and Montenegro',
'Hong Kong',
'Denmark',
'Portugal',
'Argentina',
'Afghanistan',
'Gabon',
'Dominican Republic',
'Belgium',
'Kuwait',
'United Arab Emirates',
'Cyprus',
'Israel',
'Algeria',
'Montenegro',
'Iceland',
'Paraguay',
'Cameroon',
'Saudi Arabia',
'Ireland',
'Malaysia',
'Uruguay',
'Togo',
'Mauritius',
'Syria',
'Botswana',
'Guatemala',
'Bahrain',
'Grenada',
'Uganda',
'Sudan',
'Ecuador',
'Panama',
'Eritrea',
'Sri Lanka',
'Mozambique',
'Barbados',
];
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
Overlays Copy Link
The infinite row model does not automatically show the loading overlay as rows are loaded in blocks as the user interacts with the grid. The grid will show the no rows overlay if the datasource returns an empty array and the no matching rows overlay if an empty array is returned while filters are set.
For configuration details, including suppressing the built in overlays, see Overlays.

If you are an Enterprise user you should consider using the Server-Side Row Model instead of the Infinite Row Model. It offers the same functionality with many more features. The differences between row models can be found in our row models summary page.
Infinite scrolling allows the grid to lazy-load rows from the server depending on what the scroll position is of the grid. In its simplest form, the more the user scrolls down, the more rows get loaded.
The grid will have an 'auto extending' vertical scroll. That means as the scroll reaches the bottom position, the grid will extend the height to allow scrolling even further down, almost making it impossible for the user to reach the bottom. This will stop happening once the grid has extended the scroll to reach the last record in the table.
How it Works Copy Link
The grid will ask your application, via a datasource, for the rows in blocks. Each block contains a subset of rows of the entire dataset. The following diagram is a high-level overview.
When the grid scrolls to a position where there is no corresponding block of rows loaded, the model uses the provided datasource to get the rows for the requested block. In the diagram, the datasource is getting the rows from a database in a remote server.
Turning On Infinite Scrolling Copy Link
To turn on infinite scrolling, you must a) set the grid property rowModelType to 'infinite' and b) provide a datasource.
// before grid initialised
gridOptions.rowModelType = 'infinite';
gridOptions.datasource = myDataSource;
// after grid initialised, you can set or change the datasource
api.setGridOption('datasource', myDataSource); Datasource Copy Link
A datasource must be provided to do infinite scrolling. You specify the datasource as a grid property or using the grid API.
// set as a property
gridOptions.datasource = myDatasource;
// or use the api after the grid is initialised
api.setGridOption('datasource', myDatasource); Changing the Datasource Copy Link
Changing the datasource after the grid is initialised will reset the infinite scrolling in the grid. This is useful if the context of your data changes, i.e. if you want to look at a different set of data.
If you call setGridOption('datasource', datasource) the grid will act assuming it's a new datasource, resetting the block cache. However you can pass in the same datasource instance. So your application, for example, might have one instance of a datasource that is aware of some external context (e.g. the business date selected for a report, or the 'bank ATM instance' data you are connecting to), and when the context changes, you want to reset, but still keep the same datasource instance. In this case, just call setGridOption('datasource', datasource) and pass the same datasource in again.
Datasource Interface Copy Link
In a nutshell, every time the grid wants more rows, it will call getRows() on the datasource. The datasource responds with the rows requested. Your datasource for infinite scrolling should implement the IDatasource interface:
Properties available on the IDatasource interface.
If you know up front how many rows are in the dataset, set it here. Otherwise leave blank. |
Callback the grid calls that you implement to fetch rows from the server. |
Optional destroy method, if your datasource has state it needs to clean up. |
The getRows() method takes the IGetRowsParams parameters:
Properties available on the IGetRowsParams<TData = any, TContext = any> interface.
The first row index to get. |
The first row index to NOT get. |
Callback to call for the result when successful. |
Callback to call when the request fails. |
If doing server side sorting, contains the sort model |
If doing server side filtering, contains the filter model |
The grid api. |
Application context as set on gridOptions.context. |
getRows() Copy Link
The getRows() function is called by the grid to load a block of rows into the browser-side cache of blocks. It takes the following as parameters:
The
startRowandendRowdefine the range expected for the call. For example, if thegetRowsfunction is called withstartRow: 0andendRow: 100, then the grid will expect a result with 100 rows (rows 0 to 99).The
successCallback(rowsThisBlock, lastRow)should be called when you successfully receive data from the server. The callback has the following parameters:rowsThisBlockshould be the rows you have received for the current block.lastRowshould be the index of the last row if known.
The
failCallback()should be called if the loading failed. Either one ofsuccessCallback()orfailCallback()should be called exactly once.The
filterModel()andsortModel()are passed for doing server-side sorting and filtering.The context is just passed as is and nothing to do with infinite scrolling. It's there if you need it for providing application state to your datasource.
Setting Last Row Index Copy Link
The success callback parameter lastRow is used to move the grid out of infinite scrolling. If the last row is known, then this should be the index of the last row. If the last row is unknown, then leave blank (undefined, null or -1). This attribute is only used when in infinite scrolling. Once the total record count is known, the lastRow parameter will be ignored.
Under normal operation, you will return null or undefined for lastRow for every time getRows() is called with the exception of when you get to the last block. For example, if block size is 100 and you have 250 rows, when getRows() is called for the third time, you will return back 50 rows in the result and set rowCount to 250. This will then get the grid to set the scrollbar to fit exactly 250 rows and will not ask for any more blocks.
Block Cache Copy Link
The grid keeps the blocks in a cache. You have the choice to never expire the blocks, or to set a limit to the number of blocks kept. If you set a limit, then as you scroll down, previous blocks will be discarded and will be loaded again if the user scrolls back up. The maximum blocks to keep in the cache is set using the maxBlocksInCache property.
Block Size Copy Link
The block size is set using the grid property cacheBlockSize. This is how many rows each block in the cache should contain. Each call to your datasource will be for one block.
Debounce Block Loading Copy Link
It is also possible to debounce the loading to prevent blocks loading until scrolling has stopped. This can be configured using: blockLoadDebounceMillis.
Aggregation and Grouping Copy Link
Aggregation and grouping are not available in infinite scrolling. This is because to do so would require the grid knowing the entire dataset, which is not possible when using the Infinite Row Model. If you need aggregation and / or grouping for large datasets, check the Server-Side Row Model for doing aggregations on the server-side.
Sorting & Filtering Copy Link
The grid cannot do sorting or filtering for you, as it does not have all of the data. Sorting or filtering must be done on the server-side. For this reason, if the sort or filter changes, the grid will use the datasource to get the data again and provide the sort and filter state to you.
Simple Example: No Sorting or Filtering Copy Link
The example below makes use of infinite scrolling and caching. Notice that the grid will load more data when you bring the scroll all the way to the bottom.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ICellRendererParams,
IDatasource,
IGetRowsParams,
InfiniteRowModelModule,
ModuleRegistry,
RowModelType,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([InfiniteRowModelModule]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowBuffer="rowBuffer"
:rowModelType="rowModelType"
:cacheBlockSize="cacheBlockSize"
:cacheOverflowSize="cacheOverflowSize"
:maxConcurrentDatasourceRequests="maxConcurrentDatasourceRequests"
:infiniteInitialRowCount="infiniteInitialRowCount"
:maxBlocksInCache="maxBlocksInCache"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
// this row shows the row index, doesn't use any data from the row
{
headerName: "ID",
maxWidth: 100,
// it is important to have node.id here, so that when the id changes (which happens
// when the row is loaded) then the cell is refreshed.
valueGetter: "node.id",
cellRenderer: (params: ICellRendererParams) => {
if (params.value !== undefined) {
return params.value;
} else {
return '<img src="https://www.ag-grid.com/example-assets/loading.gif">';
}
},
},
{ field: "athlete", minWidth: 150 },
{ field: "age" },
{ field: "country", minWidth: 150 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 100,
sortable: false,
});
const rowBuffer = ref(0);
const rowModelType = ref<RowModelType>("infinite");
const cacheBlockSize = ref(100);
const cacheOverflowSize = ref(2);
const maxConcurrentDatasourceRequests = ref(1);
const infiniteInitialRowCount = ref(1000);
const maxBlocksInCache = ref(10);
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => {
const dataSource: IDatasource = {
rowCount: undefined, // behave as infinite scroll
getRows: (params: IGetRowsParams) => {
console.log(
"asking for " + params.startRow + " to " + params.endRow,
);
// At this point in your code, you would call the server.
// To make the demo look real, wait for 500ms before returning
setTimeout(() => {
// take a slice of the total rows
const rowsThisPage = data.slice(params.startRow, params.endRow);
// if on or after the last page, work out the last row.
let lastRow = -1;
if (data.length <= params.endRow) {
lastRow = data.length;
}
// call the success callback
params.successCallback(rowsThisPage, lastRow);
}, 500);
},
};
params.api!.setGridOption("datasource", dataSource);
};
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowBuffer,
rowModelType,
cacheBlockSize,
cacheOverflowSize,
maxConcurrentDatasourceRequests,
infiniteInitialRowCount,
maxBlocksInCache,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Selection Copy Link
Selection works on the rows in infinite scrolling by using the Row IDs of the Row Nodes. If you do not provide Keys for the Row Nodes, the index of the Row Node will be used. Using the index of the row breaks down when (server-side) filtering or sorting, as these change the index of the Rows. For this reason, if you do not provide your own Row IDs, then selection is cleared if sort or filter is changed.
To provide your own Row IDs, implement the method getRowId(params), which should return the Key for the data.
gridOptions.getRowId: function(params) {
// the ID can be any string, as long as it's unique within your dataset
return params.data.id.toString();
}Once you have getRowId() implemented, selection will persist across sorts and filters.
The infinite row model does not have built-in support for Select-All functionality. Neither clicking the header checkbox nor pressing ^ Ctrl⌘ Command+A will have any effect.
Example: Sorting, Filtering and Selection Copy Link
The following example extends the example above by adding server-side sorting, filtering and persistent selection.
Any column can be sorted by clicking the header. When this happens, the datasource is called again with the new sort options.
The columns Age, Country and Year can be filtered. When this happens, the datasource is called again with the new filtering options.
When a row is selected, the selection will remain inside the grid, even if the grid gets sorted or filtered. Notice that when the grid loads a selected row (e.g. select first row, scroll down so the first block is removed from cache, then scroll back up again) the row is not highlighted until the row is loaded from the server. This is because the grid is waiting to see what the ID is of the row to be loaded.
The example below uses AG Grid Enterprise, to demonstrate the set filter with server-side filtering. AG Grid Enterprise is not required for infinite scrolling.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
ColDef,
ColGroupDef,
GetRowIdFunc,
GetRowIdParams,
GridApi,
GridOptions,
GridReadyEvent,
ICellRendererParams,
IDatasource,
IGetRowsParams,
InfiniteRowModelModule,
ModuleRegistry,
NumberFilterModule,
RowModelType,
RowSelectionModule,
RowSelectionOptions,
SortModelItem,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { getCountries } from "./countries";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
RowSelectionModule,
ColumnsToolPanelModule,
InfiniteRowModelModule,
ColumnMenuModule,
ContextMenuModule,
SetFilterModule,
NumberFilterModule,
]);
const filterParams = { values: getCountries() };
function sortAndFilter(
allOfTheData: any,
sortModel: SortModelItem[],
filterModel: any,
) {
return sortData(sortModel, filterData(filterModel, allOfTheData));
}
function sortData(sortModel: SortModelItem[], data: any[]) {
const sortPresent = sortModel && sortModel.length > 0;
if (!sortPresent) {
return data;
}
// do an in memory sort of the data, across all the fields
const resultOfSort = data.slice();
resultOfSort.sort(function (a, b) {
for (let k = 0; k < sortModel.length; k++) {
const sortColModel = sortModel[k];
const valueA = a[sortColModel.colId];
const valueB = b[sortColModel.colId];
// this filter didn't find a difference, move onto the next one
if (valueA == valueB) {
continue;
}
const sortDirection = sortColModel.sort === "asc" ? 1 : -1;
if (valueA > valueB) {
return sortDirection;
} else {
return sortDirection * -1;
}
}
// no filters found a difference
return 0;
});
return resultOfSort;
}
function filterData(filterModel: any, data: any[]) {
const filterPresent = filterModel && Object.keys(filterModel).length > 0;
if (!filterPresent) {
return data;
}
const resultOfFilter = [];
for (let i = 0; i < data.length; i++) {
const item = data[i];
if (filterModel.age) {
const age = item.age;
const allowedAge = parseInt(filterModel.age.filter);
// EQUALS = 1;
// LESS_THAN = 2;
// GREATER_THAN = 3;
if (filterModel.age.type == "equals") {
if (age !== allowedAge) {
continue;
}
} else if (filterModel.age.type == "lessThan") {
if (age >= allowedAge) {
continue;
}
} else {
if (age <= allowedAge) {
continue;
}
}
}
if (filterModel.year) {
if (filterModel.year.values.indexOf(item.year.toString()) < 0) {
// year didn't match, so skip this record
continue;
}
}
if (filterModel.country) {
if (filterModel.country.values.indexOf(item.country) < 0) {
continue;
}
}
resultOfFilter.push(item);
}
return resultOfFilter;
}
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowSelection="rowSelection"
:rowModelType="rowModelType"
:cacheBlockSize="cacheBlockSize"
:cacheOverflowSize="cacheOverflowSize"
:maxConcurrentDatasourceRequests="maxConcurrentDatasourceRequests"
:infiniteInitialRowCount="infiniteInitialRowCount"
:maxBlocksInCache="maxBlocksInCache"
:getRowId="getRowId"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
// this row just shows the row index, doesn't use any data from the row
{
headerName: "ID",
maxWidth: 100,
valueGetter: "node.id",
cellRenderer: (params: ICellRendererParams) => {
if (params.value !== undefined) {
return params.value;
} else {
return '<img src="https://www.ag-grid.com/example-assets/loading.gif">';
}
},
// we don't want to sort by the row index, this doesn't make sense as the point
// of the row index is to know the row index in what came back from the server
sortable: false,
suppressHeaderMenuButton: true,
},
{ field: "athlete", suppressHeaderMenuButton: true },
{
field: "age",
filter: "agNumberColumnFilter",
filterParams: {
filterOptions: ["equals", "lessThan", "greaterThan"],
maxNumConditions: 1,
},
},
{
field: "country",
filter: "agSetColumnFilter",
filterParams: filterParams,
},
{
field: "year",
filter: "agSetColumnFilter",
filterParams: { values: ["2000", "2004", "2008", "2012"] },
},
{ field: "date" },
{ field: "sport", suppressHeaderMenuButton: true },
{ field: "gold", suppressHeaderMenuButton: true },
{ field: "silver", suppressHeaderMenuButton: true },
{ field: "bronze", suppressHeaderMenuButton: true },
{ field: "total", suppressHeaderMenuButton: true },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 150,
floatingFilter: true,
});
const rowSelection = ref<RowSelectionOptions | "single" | "multiple">({
mode: "multiRow",
headerCheckbox: false,
});
const rowModelType = ref<RowModelType>("infinite");
const cacheBlockSize = ref(100);
const cacheOverflowSize = ref(2);
const maxConcurrentDatasourceRequests = ref(2);
const infiniteInitialRowCount = ref(1);
const maxBlocksInCache = ref(2);
const getRowId = ref<GetRowIdFunc>((params: GetRowIdParams) => {
return params.data.id;
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => {
// give each row an id
data.forEach(function (d: any, index: number) {
d.id = "R" + (index + 1);
});
const dataSource: IDatasource = {
rowCount: undefined, // behave as infinite scroll
getRows: (params: IGetRowsParams) => {
console.log(
"asking for " + params.startRow + " to " + params.endRow,
);
// At this point in your code, you would call the server.
// To make the demo look real, wait for 500ms before returning
setTimeout(() => {
// take a slice of the total rows
const dataAfterSortingAndFiltering = sortAndFilter(
data,
params.sortModel,
params.filterModel,
);
const rowsThisPage = dataAfterSortingAndFiltering.slice(
params.startRow,
params.endRow,
);
// if on or after the last page, work out the last row.
let lastRow = -1;
if (dataAfterSortingAndFiltering.length <= params.endRow) {
lastRow = dataAfterSortingAndFiltering.length;
}
// call the success callback
params.successCallback(rowsThisPage, lastRow);
}, 500);
},
};
params.api!.setGridOption("datasource", dataSource);
};
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowSelection,
rowModelType,
cacheBlockSize,
cacheOverflowSize,
maxConcurrentDatasourceRequests,
infiniteInitialRowCount,
maxBlocksInCache,
getRowId,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
export function getCountries() {
return [
'United States',
'Russia',
'Australia',
'Canada',
'Norway',
'China',
'Zimbabwe',
'Netherlands',
'South Korea',
'Croatia',
'France',
'Japan',
'Hungary',
'Germany',
'Poland',
'South Africa',
'Sweden',
'Ukraine',
'Italy',
'Czech Republic',
'Austria',
'Finland',
'Romania',
'Great Britain',
'Jamaica',
'Singapore',
'Belarus',
'Chile',
'Spain',
'Tunisia',
'Brazil',
'Slovakia',
'Costa Rica',
'Bulgaria',
'Switzerland',
'New Zealand',
'Estonia',
'Kenya',
'Ethiopia',
'Trinidad and Tobago',
'Turkey',
'Morocco',
'Bahamas',
'Slovenia',
'Armenia',
'Azerbaijan',
'India',
'Puerto Rico',
'Egypt',
'Kazakhstan',
'Iran',
'Georgia',
'Lithuania',
'Cuba',
'Colombia',
'Mongolia',
'Uzbekistan',
'North Korea',
'Tajikistan',
'Kyrgyzstan',
'Greece',
'Macedonia',
'Moldova',
'Chinese Taipei',
'Indonesia',
'Thailand',
'Vietnam',
'Latvia',
'Venezuela',
'Mexico',
'Nigeria',
'Qatar',
'Serbia',
'Serbia and Montenegro',
'Hong Kong',
'Denmark',
'Portugal',
'Argentina',
'Afghanistan',
'Gabon',
'Dominican Republic',
'Belgium',
'Kuwait',
'United Arab Emirates',
'Cyprus',
'Israel',
'Algeria',
'Montenegro',
'Iceland',
'Paraguay',
'Cameroon',
'Saudi Arabia',
'Ireland',
'Malaysia',
'Uruguay',
'Togo',
'Mauritius',
'Syria',
'Botswana',
'Guatemala',
'Bahrain',
'Grenada',
'Uganda',
'Sudan',
'Ecuador',
'Panama',
'Eritrea',
'Sri Lanka',
'Mozambique',
'Barbados',
];
}
When performing multiple row selections using shift-click, it is possible that not all rows are available in memory if the configured value of maxBlocksInCache doesn't cover the range. In this case multiple selections will not be allowed.
Specify Selectable Rows Copy Link
It is also possible to specify which rows can be selected via the rowSelection.isRowSelectable callback function.
Callback to be used to determine which rows are selectable. By default rows are selectable, so return false to make a row non-selectable.
|
For instance if we only wanted to allow rows where the data.country property is the 'United States' we could implement the following:
<ag-grid-vue
:rowSelection="rowSelection"
/* other grid options ... */>
</ag-grid-vue>
this.rowSelection = {
mode: 'multiRow',
isRowSelectable: function(data) {
return data.country === 'United States';
}
};import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ICellRendererParams,
IDatasource,
IGetRowsParams,
IRowNode,
InfiniteRowModelModule,
ModuleRegistry,
RowModelType,
RowSelectionModule,
RowSelectionOptions,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([RowSelectionModule, InfiniteRowModelModule]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowBuffer="rowBuffer"
:rowSelection="rowSelection"
:rowModelType="rowModelType"
:cacheBlockSize="cacheBlockSize"
:cacheOverflowSize="cacheOverflowSize"
:maxConcurrentDatasourceRequests="maxConcurrentDatasourceRequests"
:infiniteInitialRowCount="infiniteInitialRowCount"
:maxBlocksInCache="maxBlocksInCache"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
// this row shows the row index, doesn't use any data from the row
{
headerName: "ID",
maxWidth: 100,
// it is important to have node.id here, so that when the id changes (which happens
// when the row is loaded) then the cell is refreshed.
valueGetter: "node.id",
cellRenderer: (params: ICellRendererParams) => {
if (params.value !== undefined) {
return params.value;
} else {
return '<img src="https://www.ag-grid.com/example-assets/loading.gif">';
}
},
},
{ field: "athlete", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 200 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 100,
sortable: false,
});
const rowBuffer = ref(0);
const rowSelection = ref<RowSelectionOptions | "single" | "multiple">({
mode: "multiRow",
hideDisabledCheckboxes: true,
headerCheckbox: false,
isRowSelectable: (rowNode: IRowNode) => {
return rowNode.data ? rowNode.data.country === "United States" : false;
},
});
const rowModelType = ref<RowModelType>("infinite");
const cacheBlockSize = ref(100);
const cacheOverflowSize = ref(2);
const maxConcurrentDatasourceRequests = ref(2);
const infiniteInitialRowCount = ref(1);
const maxBlocksInCache = ref(2);
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => {
const dataSource: IDatasource = {
rowCount: undefined, // behave as infinite scroll
getRows: (params: IGetRowsParams) => {
// console.log('asking for ' + params.startRow + ' to ' + params.endRow);
// At this point in your code, you would call the server.
// To make the demo look real, wait for 500ms before returning
setTimeout(() => {
// take a slice of the total rows
const rowsThisPage = data.slice(params.startRow, params.endRow);
// if on or after the last page, work out the last row.
let lastRow = -1;
if (data.length <= params.endRow) {
lastRow = data.length;
}
// call the success callback
params.successCallback(rowsThisPage, lastRow);
}, 500);
},
};
params.api!.setGridOption("datasource", dataSource);
};
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowBuffer,
rowSelection,
rowModelType,
cacheBlockSize,
cacheOverflowSize,
maxConcurrentDatasourceRequests,
infiniteInitialRowCount,
maxBlocksInCache,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Note that in the above example we have hidden disabled checkboxes to help highlight which rows are selectable.
Configuring a Bit Differently Copy Link
The examples above use old-style JavaScript objects for the datasource. This example turns things around slightly and creates a datasource Class. The example also just generates data on the fly.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
ColDef,
ColGroupDef,
ColumnApiModule,
GetRowIdFunc,
GetRowIdParams,
GridApi,
GridOptions,
GridReadyEvent,
IDatasource,
IGetRowsParams,
InfiniteRowModelModule,
ModuleRegistry,
RowModelType,
RowSelectionModule,
RowSelectionOptions,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ColumnApiModule,
RowSelectionModule,
InfiniteRowModelModule,
]);
const ALPHABET = "abcdefghijklmnopqrstuvwxyz".split("");
function getColumnDefs() {
const columnDefs: ColDef[] = [
{ headerName: "#", width: 80, valueGetter: "node.rowIndex" },
];
ALPHABET.forEach((letter) => {
columnDefs.push({
headerName: letter.toUpperCase(),
field: letter,
width: 150,
});
});
return columnDefs;
}
function getDataSource(count: number) {
const dataSource: IDatasource = {
rowCount: count,
getRows: (params: IGetRowsParams) => {
const rowsThisPage: any[] = [];
for (
var rowIndex = params.startRow;
rowIndex < params.endRow;
rowIndex++
) {
var record: Record<string, string> = {};
ALPHABET.forEach(function (letter, colIndex) {
const randomNumber = 17 + rowIndex + colIndex;
const cellKey = letter.toUpperCase() + (rowIndex + 1);
record[letter] = cellKey + " = " + randomNumber;
});
rowsThisPage.push(record);
}
// to mimic server call, we reply after a short delay
setTimeout(() => {
// no need to pass the second 'rowCount' parameter as we have already provided it
params.successCallback(rowsThisPage);
}, 100);
},
};
return dataSource;
}
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:rowModelType="rowModelType"
:rowSelection="rowSelection"
:maxBlocksInCache="maxBlocksInCache"
:getRowId="getRowId"
:datasource="datasource"
:defaultColDef="defaultColDef"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi | null>(null);
const columnDefs = ref<ColDef[]>(getColumnDefs());
const rowModelType = ref<RowModelType>("infinite");
const rowSelection = ref<RowSelectionOptions | "single" | "multiple">({
mode: "multiRow",
headerCheckbox: false,
});
const maxBlocksInCache = ref(2);
const getRowId = ref<GetRowIdFunc>((params: GetRowIdParams) => {
return params.data.a;
});
const datasource = ref<IDatasource>(getDataSource(100));
const defaultColDef = ref<ColDef>({
sortable: false,
});
const rowData = ref<any[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
};
return {
gridApi,
columnDefs,
rowModelType,
rowSelection,
maxBlocksInCache,
getRowId,
datasource,
defaultColDef,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Loading Spinner Copy Link
The examples on this page use a loading spinner to show if the row is waiting for its data to be loaded. The grid does not provide this, rather it is a simple rendering technique used in the examples. If the data is loading, then the rowNode will have no ID, so if you use the ID as the value, the cell will get refreshed when the ID is set.
loadingSpinnerColumn = {
// use a value getter to have the node ID as this column's value
valueGetter: 'node.id',
// then a custom cellRenderer
cellRenderer: function(params) {
if (params.value === undefined) {
// when no node id, display the spinner image
return '<img src="loading.gif" />';
} else {
// otherwise just display node ID (or whatever you wish for this column)
return params.value;
}
}
}Refer to section Cell Rendering for how to build cell renderers.
More Control via Properties and API Copy Link
Infinite scrolling has a cache working behind the scenes. The following properties and API are provided to give you control of the cache.
Properties Copy Link
How many extra blank rows to display to the user at the end of the dataset, which sets the vertical scroll and then allows the grid to request viewing more rows of data. |
How many requests to hit the server with concurrently. If the max is reached, requests are queued.
Set to -1 for no maximum restriction on requests. |
How many rows for each block in the store, i.e. how many rows returned from the server at a time. |
How many blocks to keep in the store. Default is no limit, so every requested block is kept. Use this if you have memory concerns, and blocks that were least recently viewed will be purged when the limit is hit. The grid will additionally make sure it has all the blocks needed to display what is currently visible, in case this property is set to a low value. |
How many extra blank rows to display to the user at the end of the dataset, which sets the vertical scroll and then allows the grid to request viewing more rows of data. |
API Copy Link
Marks all the currently loaded blocks in the cache for reload.
If you have 10 blocks in the cache, all 10 will be marked for reload.
The old data will continue to be displayed until the new data is loaded. |
Purges the cache.
The grid is then told to refresh. Only the blocks required to display the current data on screen are fetched (typically no more than 2).
The grid will display nothing while the new blocks are loaded.
Use this to immediately remove the old data from the user. |
Returns false if grid allows for scrolling past the last row to load more rows, thus providing infinite scroll. |
Sets the rowCount and maxRowFound properties.
The second parameter, maxRowFound, is optional and if left out, only rowCount is set.
Set rowCount to adjust the height of the vertical scroll.
Set maxRowFound to enable / disable searching for more rows.
Use this method if you add or remove rows into the dataset and need to reset the number of rows or instruct the grid that the entire row count is no longer known. |
Returns an object representing the state of the cache. This is useful for debugging and understanding how the cache is working. |
Adding / removing rows directly in the grid for infinite scrolling is not recommended as it will complicate your application. It will make your life easier if you update the data on the server and refresh the block cache.
Example: Using Cache API Methods Copy Link
Below demonstrates the different API methods via the buttons. The example outputs a lot of debugging items to the console because the grid property debug=true is set. The buttons are as follows:
- Insert Rows: Inserts 5 rows at row index 2 from the server, then refreshes the grid.
- Delete Rows: Deletes 10 rows at row index 3 from the server, then refreshes the grid.
- Set Row Count: Sets the row count to 200. This adjusts the vertical scroll to show 200 rows. If the scroll is positioned at the end, this results in the grid automatically re-adjusting as it seeks ahead for the next block of data.
- Print Info: Prints
rowCountandmaxFoundto the console. - Jump to 500: Positions the grid so that row 500 is displayed.
- Print Cache State: Debugging method, to see the state of the cache.
- Set Prices High & Set Prices Low: Sets the prices on the server-side to either high or low prices. This will not impact the grid until after a block cache is loaded. Use these buttons to then further test the refresh and purge methods.
- Refresh Cache: Calls for the cache to be refreshed.
- Purge Cache: Calls for the cache to be purged.
The example also makes each Honda row bold - demonstrating that the callbacks getRowStyle and getRowClass get called after the data is set as well as when the row is created (when the data may not yet be available).
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
ColDef,
ColGroupDef,
GetRowIdFunc,
GetRowIdParams,
GetRowStyle,
GridApi,
GridOptions,
GridReadyEvent,
ICellRendererParams,
IDatasource,
IGetRowsParams,
InfiniteRowModelModule,
ModuleRegistry,
RowApiModule,
RowClassParams,
RowModelType,
RowStyle,
RowStyleModule,
ScrollApiModule,
ValueFormatterParams,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
RowApiModule,
ScrollApiModule,
RowStyleModule,
InfiniteRowModelModule,
]);
const valueFormatter = function (params: ValueFormatterParams) {
if (typeof params.value === "number") {
return "£" + params.value.toLocaleString();
} else {
return params.value;
}
};
// this counter is used to give id's to the rows
var sequenceId = 0;
var allOfTheData: any[] = [];
function createRowData(id: number) {
const makes = ["Toyota", "Ford", "Porsche", "Chevy", "Honda", "Nissan"];
const models = [
"Cruze",
"Celica",
"Mondeo",
"Boxster",
"Genesis",
"Accord",
"Taurus",
];
return {
id: id,
make: makes[id % makes.length],
model: models[id % models.length],
price: 72000,
};
}
function insertItemsAt2(count: number) {
const newDataItems = [];
for (let i = 0; i < count; i++) {
const newItem = createRowData(sequenceId++);
allOfTheData.splice(2, 0, newItem);
newDataItems.push(newItem);
}
return newDataItems;
}
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div style="display: flex; flex-direction: column; height: 100%">
<div style="margin-bottom: 10px">
<button v-on:click="insertItemsAt2AndRefresh(5)">Insert Rows</button>
<button v-on:click="removeItem(3, 10)">Delete Rows</button>
<button v-on:click="setRowCountTo200()">Set Row Count</button>
<button v-on:click="rowsAndMaxFound()">Print Info</button>
<button v-on:click="jumpTo500()">Jump to 500</button>
</div>
<div style="margin-bottom: 10px">
<button v-on:click="setPricesHigh()">Set Prices High</button>
<button v-on:click="setPricesLow()">Set Prices Low</button>
<button v-on:click="refreshCache()">Refresh Cache</button>
<button v-on:click="purgeCache()">Purge Cache</button>
</div>
<div style="flex-grow: 1">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:datasource="datasource"
:defaultColDef="defaultColDef"
:rowModelType="rowModelType"
:maxBlocksInCache="maxBlocksInCache"
:infiniteInitialRowCount="infiniteInitialRowCount"
:maxConcurrentDatasourceRequests="maxConcurrentDatasourceRequests"
:getRowId="getRowId"
:getRowStyle="getRowStyle"
:rowData="rowData"></ag-grid-vue>
</div>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi | null>(null);
const columnDefs = ref<ColDef[]>([
{
headerName: "Item ID",
field: "id",
valueGetter: "node.id",
cellRenderer: (params: ICellRendererParams) => {
if (params.value !== undefined) {
return params.value;
} else {
return '<img src="https://www.ag-grid.com/example-assets/loading.gif">';
}
},
},
{ field: "make" },
{ field: "model" },
{
field: "price",
valueFormatter: valueFormatter,
},
]);
const datasource = ref<IDatasource>({
rowCount: undefined, // behave as infinite scroll
getRows: (params: IGetRowsParams) => {
console.log("asking for " + params.startRow + " to " + params.endRow);
// At this point in your code, you would call the server.
// To make the demo look real, wait for 500ms before returning
setTimeout(() => {
// take a slice of the total rows
const rowsThisPage = allOfTheData.slice(
params.startRow,
params.endRow,
);
// make a copy of each row - this is what would happen if taking data from server
for (let i = 0; i < rowsThisPage.length; i++) {
const item = rowsThisPage[i];
// this is a trick to copy an object
const itemCopy = JSON.parse(JSON.stringify(item));
rowsThisPage[i] = itemCopy;
}
// if on or after the last page, work out the last row.
let lastRow = -1;
if (allOfTheData.length <= params.endRow) {
lastRow = allOfTheData.length;
}
// call the success callback
params.successCallback(rowsThisPage, lastRow);
}, 500);
},
});
const defaultColDef = ref<ColDef>({
flex: 1,
sortable: false,
});
const rowModelType = ref<RowModelType>("infinite");
const maxBlocksInCache = ref(2);
const infiniteInitialRowCount = ref(500);
const maxConcurrentDatasourceRequests = ref(2);
const getRowId = ref<GetRowIdFunc>((params: GetRowIdParams) => {
return params.data.id.toString();
});
const getRowStyle = ref<GetRowStyle>(
(params: RowClassParams): RowStyle | undefined => {
if (params.data && params.data.make === "Honda") {
return {
fontWeight: "bold",
};
}
return {
fontWeight: "normal",
};
},
);
const rowData = ref<any[]>(null);
function insertItemsAt2AndRefresh(count: number) {
insertItemsAt2(count);
// if the data has stopped looking for the last row, then we need to adjust the
// row count to allow for the extra data, otherwise the grid will not allow scrolling
// to the last row. eg if we have 1000 rows, scroll all the way to the bottom (so
// maxRowFound=true), and then add 5 rows, the rowCount needs to be adjusted
// to 1005, so grid can scroll to the end. the grid does NOT do this for you in the
// refreshInfiniteCache() method, as this would be assuming you want to do it which
// is not true, maybe the row count is constant and you just want to refresh the details.
const maxRowFound = gridApi.value!.isLastRowIndexKnown();
if (maxRowFound) {
const rowCount = gridApi.value!.getDisplayedRowCount() || 0;
gridApi.value!.setRowCount(rowCount + count);
}
// get grid to refresh the data
gridApi.value!.refreshInfiniteCache();
}
function removeItem(start: number, limit: number) {
allOfTheData.splice(start, limit);
gridApi.value!.refreshInfiniteCache();
}
function refreshCache() {
gridApi.value!.refreshInfiniteCache();
}
function purgeCache() {
gridApi.value!.purgeInfiniteCache();
}
function setRowCountTo200() {
gridApi.value!.setRowCount(200, false);
}
function rowsAndMaxFound() {
console.log(
"getDisplayedRowCount() => " + gridApi.value!.getDisplayedRowCount(),
);
console.log(
"isLastRowIndexKnown() => " + gridApi.value!.isLastRowIndexKnown(),
);
}
// function just gives new prices to the row data, it does not update the grid
function setPricesHigh() {
allOfTheData.forEach((dataItem) => {
dataItem.price = Math.round(55500 + 400 * (0.5 + window.agRandom()));
});
}
function setPricesLow() {
allOfTheData.forEach((dataItem) => {
dataItem.price = Math.round(1000 + 100 * (0.5 + window.agRandom()));
});
}
function jumpTo500() {
// first up, need to make sure the grid is actually showing 500 or more rows
if ((gridApi.value!.getDisplayedRowCount() || 0) < 501) {
gridApi.value!.setRowCount(501, false);
}
// next, we can jump to the row
gridApi.value!.ensureIndexVisible(500);
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
sequenceId = 1;
allOfTheData = [];
for (let i = 0; i < 1000; i++) {
allOfTheData.push(createRowData(sequenceId++));
}
};
return {
gridApi,
columnDefs,
datasource,
defaultColDef,
rowModelType,
maxBlocksInCache,
infiniteInitialRowCount,
maxConcurrentDatasourceRequests,
getRowId,
getRowStyle,
rowData,
onGridReady,
insertItemsAt2AndRefresh,
removeItem,
refreshCache,
purgeCache,
setRowCountTo200,
rowsAndMaxFound,
setPricesHigh,
setPricesLow,
jumpTo500,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Changing Columns Copy Link
Changing columns is possible using infinite scroll and it does not require the data getting fetched again from the server. If the change of columns impacts the sort or filter (i.e. a column with a sort or filter applied is removed), the grid will fetch data again similar to how data is fetched again after the user changes the sort or filter explicitly.
The example below demonstrates changing columns on the infinite row model. The following can be noted:
- Hit the buttons 'Show Year' and 'Hide Year'. Notice that the data is not re-fetched.
- Add a sort or filter to Age column. When the sort or filter is applied the data is re-fetched. However once fetched, you can add and remove the Year column without re-fetching the data.
- Add a sort or filter to the Year column. When the sort or filter is applied the data is re-fetched. Now remove the Year column and the data is re-fetched again as the sort or filter has changed.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./style.css";
import {
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
IDatasource,
InfiniteRowModelModule,
ModuleRegistry,
RowModelType,
SortModelItem,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([TextFilterModule, InfiniteRowModelModule]);
function sortAndFilter(
allOfTheData: any[],
sortModel: SortModelItem[],
filterModel: any,
) {
return sortData(sortModel, filterData(filterModel, allOfTheData));
}
function sortData(sortModel: SortModelItem[], data: any[]) {
const sortPresent = sortModel && sortModel.length > 0;
if (!sortPresent) {
return data;
}
// do an in memory sort of the data, across all the fields
const resultOfSort = data.slice();
resultOfSort.sort(function (a, b) {
for (let k = 0; k < sortModel.length; k++) {
const sortColModel = sortModel[k];
const valueA = a[sortColModel.colId];
const valueB = b[sortColModel.colId];
// this filter didn't find a difference, move onto the next one
if (valueA == valueB) {
continue;
}
const sortDirection = sortColModel.sort === "asc" ? 1 : -1;
if (valueA > valueB) {
return sortDirection;
} else {
return sortDirection * -1;
}
}
// no filters found a difference
return 0;
});
return resultOfSort;
}
function filterData(filterModel: any, data: any[]) {
const filterPresent = filterModel && Object.keys(filterModel).length > 0;
if (!filterPresent) {
return data;
}
const resultOfFilter = [];
for (let i = 0; i < data.length; i++) {
var item = data[i];
var filterFails = false;
const filterKeys = Object.keys(filterModel);
filterKeys.forEach((filterKey) => {
const filterValue = filterModel[filterKey].filter;
const valueForRow = item[filterKey];
if (filterValue != valueForRow) {
// year didn't match, so skip this record
filterFails = true;
}
});
// if (filterModel.year) {
// var val1 = filterModel.year.filter;
// var val2 = item.year;
// if (val1 != val2) {
// // year didn't match, so skip this record
// continue;
// }
// }
//
if (!filterFails) {
resultOfFilter.push(item);
}
}
return resultOfFilter;
}
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div class="test-container">
<div class="test-header">
<button v-on:click="onBtShowYearColumn()">Show Year</button>
<button v-on:click="onBtHideYearColumn()">Hide Year</button>
</div>
<ag-grid-vue
style="width: 100%; height: 100%;"
class="test-grid"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowModelType="rowModelType"
:rowData="rowData"></ag-grid-vue>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", colId: "athlete", minWidth: 180 },
{ field: "age", colId: "age" },
{ field: "country", colId: "country", minWidth: 180 },
{ field: "year", colId: "year" },
{ field: "sport", colId: "sport", minWidth: 180 },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
filter: true,
});
const rowModelType = ref<RowModelType>("infinite");
const rowData = ref<IOlympicData[]>(null);
function onBtShowYearColumn() {
gridApi.value!.setGridOption("columnDefs", [
{ field: "athlete", colId: "athlete" },
{ field: "age", colId: "age" },
{ field: "country", colId: "country" },
{ field: "year", colId: "year" },
{ field: "sport", colId: "sport" },
]);
}
function onBtHideYearColumn() {
gridApi.value!.setGridOption("columnDefs", [
{ field: "athlete", colId: "athlete" },
{ field: "age", colId: "age" },
{ field: "country", colId: "country" },
{ field: "sport", colId: "sport" },
]);
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => {
// give each row an id
data.forEach(function (d: any, index: number) {
d.id = "R" + (index + 1);
});
const dataSource: IDatasource = {
rowCount: undefined, // behave as infinite scroll
getRows: (params) => {
console.log(
"asking for " + params.startRow + " to " + params.endRow,
);
// At this point in your code, you would call the server.
// To make the demo look real, wait for 500ms before returning
setTimeout(() => {
// take a slice of the total rows
const dataAfterSortingAndFiltering = sortAndFilter(
data,
params.sortModel,
params.filterModel,
);
const rowsThisPage = dataAfterSortingAndFiltering.slice(
params.startRow,
params.endRow,
);
// if on or after the last page, work out the last row.
let lastRow = -1;
if (dataAfterSortingAndFiltering.length <= params.endRow) {
lastRow = dataAfterSortingAndFiltering.length;
}
// call the success callback
params.successCallback(rowsThisPage, lastRow);
}, 500);
},
};
params.api!.setGridOption("datasource", dataSource);
};
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowModelType,
rowData,
onGridReady,
onBtShowYearColumn,
onBtHideYearColumn,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.test-grid {
height: 1px;
min-height: 1px;
flex-grow: 1;
}
.test-container {
height: 100%;
display: flex;
flex-direction: column;
}
.test-header {
margin-bottom: 5px;
}
Pagination Copy Link
As with all row models, it is possible to enable pagination with infinite scrolling. With infinite scrolling, it is possible to mix and match with the configuration to achieve different effects. The following examples are presented:
| Example | Page Size | Block Size | Comment |
|---|---|---|---|
| Example 1 | Auto | Large | Most Recommended |
| Example 2 | Equal | Equal | Recommended Sometimes |
Having smaller infinite blocks size than your pagination page size is not supported
You must have infinite block size greater than or equal to the pagination page size. If you have a smaller block size, the grid will not fetch enough rows to display one page. This breaks how infinite scrolling works and is not supported.
Example 1: Auto Pagination Page Size, Large Infinite Block Size Copy Link
This example is the recommended approach. The infinite block size is larger than the pages size, so the grid loads data for a few pages, allowing the user to hit 'next' a few times before a server sided call is needed.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
ColDef,
ColGroupDef,
GetRowIdFunc,
GetRowIdParams,
GridApi,
GridOptions,
GridReadyEvent,
ICellRendererParams,
IDatasource,
IGetRowsParams,
InfiniteRowModelModule,
ModuleRegistry,
NumberFilterModule,
PaginationModule,
RowModelType,
SortModelItem,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { countries } from "./countries";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
PaginationModule,
ColumnsToolPanelModule,
InfiniteRowModelModule,
ColumnMenuModule,
ContextMenuModule,
SetFilterModule,
NumberFilterModule,
]);
const filterParams = { values: countries() };
function sortAndFilter(
allOfTheData: any[],
sortModel: SortModelItem[],
filterModel: any,
) {
return sortData(sortModel, filterData(filterModel, allOfTheData));
}
function sortData(sortModel: SortModelItem[], data: any[]) {
const sortPresent = sortModel && sortModel.length > 0;
if (!sortPresent) {
return data;
}
// do an in memory sort of the data, across all the fields
const resultOfSort = data.slice();
resultOfSort.sort(function (a, b) {
for (let k = 0; k < sortModel.length; k++) {
const sortColModel = sortModel[k];
const valueA = a[sortColModel.colId];
const valueB = b[sortColModel.colId];
// this filter didn't find a difference, move onto the next one
if (valueA == valueB) {
continue;
}
const sortDirection = sortColModel.sort === "asc" ? 1 : -1;
if (valueA > valueB) {
return sortDirection;
} else {
return sortDirection * -1;
}
}
// no filters found a difference
return 0;
});
return resultOfSort;
}
function filterData(filterModel: any, data: any[]) {
const filterPresent = filterModel && Object.keys(filterModel).length > 0;
if (!filterPresent) {
return data;
}
const resultOfFilter = [];
for (let i = 0; i < data.length; i++) {
const item = data[i];
if (filterModel.age) {
const age = item.age;
const allowedAge = parseInt(filterModel.age.filter);
// EQUALS = 1;
// LESS_THAN = 2;
// GREATER_THAN = 3;
if (filterModel.age.type == "equals") {
if (age !== allowedAge) {
continue;
}
} else if (filterModel.age.type == "lessThan") {
if (age >= allowedAge) {
continue;
}
} else {
if (age <= allowedAge) {
continue;
}
}
}
if (filterModel.year) {
if (filterModel.year.values.indexOf(item.year.toString()) < 0) {
// year didn't match, so skip this record
continue;
}
}
if (filterModel.country) {
if (filterModel.country.values.indexOf(item.country) < 0) {
continue;
}
}
resultOfFilter.push(item);
}
return resultOfFilter;
}
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowModelType="rowModelType"
:cacheBlockSize="cacheBlockSize"
:cacheOverflowSize="cacheOverflowSize"
:maxConcurrentDatasourceRequests="maxConcurrentDatasourceRequests"
:infiniteInitialRowCount="infiniteInitialRowCount"
:maxBlocksInCache="maxBlocksInCache"
:pagination="true"
:paginationAutoPageSize="true"
:getRowId="getRowId"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
// this row just shows the row index, doesn't use any data from the row
{
headerName: "ID",
maxWidth: 100,
valueGetter: "node.id",
cellRenderer: (params: ICellRendererParams) => {
if (params.value !== undefined) {
return params.value;
} else {
return '<img src="https://www.ag-grid.com/example-assets/loading.gif">';
}
},
// we don't want to sort by the row index, this doesn't make sense as the point
// of the row index is to know the row index in what came back from the server
sortable: false,
suppressHeaderMenuButton: true,
},
{
headerName: "Athlete",
field: "athlete",
suppressHeaderMenuButton: true,
},
{
field: "age",
filter: "agNumberColumnFilter",
filterParams: {
filterOptions: ["equals", "lessThan", "greaterThan"],
},
},
{
field: "country",
filter: "agSetColumnFilter",
filterParams: filterParams,
},
{
field: "year",
filter: "agSetColumnFilter",
filterParams: { values: ["2000", "2004", "2008", "2012"] },
},
{ field: "date" },
{ field: "sport", suppressHeaderMenuButton: true },
{ field: "gold", suppressHeaderMenuButton: true },
{ field: "silver", suppressHeaderMenuButton: true },
{ field: "bronze", suppressHeaderMenuButton: true },
{ field: "total", suppressHeaderMenuButton: true },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 150,
floatingFilter: true,
});
const rowModelType = ref<RowModelType>("infinite");
const cacheBlockSize = ref(100);
const cacheOverflowSize = ref(2);
const maxConcurrentDatasourceRequests = ref(2);
const infiniteInitialRowCount = ref(1);
const maxBlocksInCache = ref(2);
const getRowId = ref<GetRowIdFunc>((params: GetRowIdParams) => {
return params.data.id;
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => {
data.forEach(function (d: any, index: number) {
d.id = "R" + (index + 1);
});
const dataSource: IDatasource = {
rowCount: undefined, // behave as infinite scroll
getRows: (params: IGetRowsParams) => {
console.log(
"asking for " + params.startRow + " to " + params.endRow,
);
// At this point in your code, you would call the server.
// To make the demo look real, wait for 500ms before returning
setTimeout(() => {
// take a slice of the total rows
const dataAfterSortingAndFiltering = sortAndFilter(
data,
params.sortModel,
params.filterModel,
);
const rowsThisPage = dataAfterSortingAndFiltering.slice(
params.startRow,
params.endRow,
);
// if on or after the last page, work out the last row.
let lastRow = -1;
if (dataAfterSortingAndFiltering.length <= params.endRow) {
lastRow = dataAfterSortingAndFiltering.length;
}
// call the success callback
params.successCallback(rowsThisPage, lastRow);
}, 500);
},
};
params.api!.setGridOption("datasource", dataSource);
};
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowModelType,
cacheBlockSize,
cacheOverflowSize,
maxConcurrentDatasourceRequests,
infiniteInitialRowCount,
maxBlocksInCache,
getRowId,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
export function countries() {
return [
'United States',
'Russia',
'Australia',
'Canada',
'Norway',
'China',
'Zimbabwe',
'Netherlands',
'South Korea',
'Croatia',
'France',
'Japan',
'Hungary',
'Germany',
'Poland',
'South Africa',
'Sweden',
'Ukraine',
'Italy',
'Czech Republic',
'Austria',
'Finland',
'Romania',
'Great Britain',
'Jamaica',
'Singapore',
'Belarus',
'Chile',
'Spain',
'Tunisia',
'Brazil',
'Slovakia',
'Costa Rica',
'Bulgaria',
'Switzerland',
'New Zealand',
'Estonia',
'Kenya',
'Ethiopia',
'Trinidad and Tobago',
'Turkey',
'Morocco',
'Bahamas',
'Slovenia',
'Armenia',
'Azerbaijan',
'India',
'Puerto Rico',
'Egypt',
'Kazakhstan',
'Iran',
'Georgia',
'Lithuania',
'Cuba',
'Colombia',
'Mongolia',
'Uzbekistan',
'North Korea',
'Tajikistan',
'Kyrgyzstan',
'Greece',
'Macedonia',
'Moldova',
'Chinese Taipei',
'Indonesia',
'Thailand',
'Vietnam',
'Latvia',
'Venezuela',
'Mexico',
'Nigeria',
'Qatar',
'Serbia',
'Serbia and Montenegro',
'Hong Kong',
'Denmark',
'Portugal',
'Argentina',
'Afghanistan',
'Gabon',
'Dominican Republic',
'Belgium',
'Kuwait',
'United Arab Emirates',
'Cyprus',
'Israel',
'Algeria',
'Montenegro',
'Iceland',
'Paraguay',
'Cameroon',
'Saudi Arabia',
'Ireland',
'Malaysia',
'Uruguay',
'Togo',
'Mauritius',
'Syria',
'Botswana',
'Guatemala',
'Bahrain',
'Grenada',
'Uganda',
'Sudan',
'Ecuador',
'Panama',
'Eritrea',
'Sri Lanka',
'Mozambique',
'Barbados',
];
}
Example 2: Equal Pagination Page Size and Large Infinite Block Size Copy Link
This example demonstrates having the page and block sizes equal. Here the server is hit every time a new page is navigated to.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
ColDef,
ColGroupDef,
GetRowIdFunc,
GetRowIdParams,
GridApi,
GridOptions,
GridReadyEvent,
ICellRendererParams,
IDatasource,
IGetRowsParams,
InfiniteRowModelModule,
ModuleRegistry,
NumberFilterModule,
PaginationModule,
RowModelType,
SortModelItem,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { countries } from "./countries";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
PaginationModule,
ColumnsToolPanelModule,
InfiniteRowModelModule,
ColumnMenuModule,
ContextMenuModule,
SetFilterModule,
NumberFilterModule,
]);
const filterParams = { values: countries() };
function sortAndFilter(
allOfTheData: any[],
sortModel: SortModelItem[],
filterModel: any,
) {
return sortData(sortModel, filterData(filterModel, allOfTheData));
}
function sortData(sortModel: SortModelItem[], data: any[]) {
const sortPresent = sortModel && sortModel.length > 0;
if (!sortPresent) {
return data;
}
// do an in memory sort of the data, across all the fields
const resultOfSort = data.slice();
resultOfSort.sort(function (a, b) {
for (let k = 0; k < sortModel.length; k++) {
const sortColModel = sortModel[k];
const valueA = a[sortColModel.colId];
const valueB = b[sortColModel.colId];
// this filter didn't find a difference, move onto the next one
if (valueA == valueB) {
continue;
}
const sortDirection = sortColModel.sort === "asc" ? 1 : -1;
if (valueA > valueB) {
return sortDirection;
} else {
return sortDirection * -1;
}
}
// no filters found a difference
return 0;
});
return resultOfSort;
}
function filterData(filterModel: any, data: any[]) {
const filterPresent = filterModel && Object.keys(filterModel).length > 0;
if (!filterPresent) {
return data;
}
const resultOfFilter = [];
for (let i = 0; i < data.length; i++) {
const item = data[i];
if (filterModel.age) {
const age = item.age;
const allowedAge = parseInt(filterModel.age.filter);
// EQUALS = 1;
// LESS_THAN = 2;
// GREATER_THAN = 3;
if (filterModel.age.type == "equals") {
if (age !== allowedAge) {
continue;
}
} else if (filterModel.age.type == "lessThan") {
if (age >= allowedAge) {
continue;
}
} else {
if (age <= allowedAge) {
continue;
}
}
}
if (filterModel.year) {
if (filterModel.year.values.indexOf(item.year.toString()) < 0) {
// year didn't match, so skip this record
continue;
}
}
if (filterModel.country) {
if (filterModel.country.values.indexOf(item.country) < 0) {
continue;
}
}
resultOfFilter.push(item);
}
return resultOfFilter;
}
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowModelType="rowModelType"
:cacheOverflowSize="cacheOverflowSize"
:maxConcurrentDatasourceRequests="maxConcurrentDatasourceRequests"
:infiniteInitialRowCount="infiniteInitialRowCount"
:maxBlocksInCache="maxBlocksInCache"
:pagination="true"
:getRowId="getRowId"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi | null>(null);
const columnDefs = ref<ColDef[]>([
// this row just shows the row index, doesn't use any data from the row
{
headerName: "ID",
maxWidth: 100,
valueGetter: "node.id",
cellRenderer: (params: ICellRendererParams) => {
if (params.value !== undefined) {
return params.value;
} else {
return '<img src="https://www.ag-grid.com/example-assets/loading.gif">';
}
},
// we don't want to sort by the row index, this doesn't make sense as the point
// of the row index is to know the row index in what came back from the server
sortable: false,
suppressHeaderMenuButton: true,
},
{
headerName: "Athlete",
field: "athlete",
width: 150,
suppressHeaderMenuButton: true,
},
{
field: "age",
filter: "agNumberColumnFilter",
filterParams: {
filterOptions: ["equals", "lessThan", "greaterThan"],
},
},
{
field: "country",
filter: "agSetColumnFilter",
filterParams: filterParams,
},
{
field: "year",
filter: "agSetColumnFilter",
filterParams: { values: ["2000", "2004", "2008", "2012"] },
},
{ field: "date" },
{ field: "sport", suppressHeaderMenuButton: true },
{ field: "gold", suppressHeaderMenuButton: true },
{ field: "silver", suppressHeaderMenuButton: true },
{ field: "bronze", suppressHeaderMenuButton: true },
{ field: "total", suppressHeaderMenuButton: true },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 150,
floatingFilter: true,
});
const rowModelType = ref<RowModelType>("infinite");
const cacheOverflowSize = ref(2);
const maxConcurrentDatasourceRequests = ref(2);
const infiniteInitialRowCount = ref(1);
const maxBlocksInCache = ref(2);
const getRowId = ref<GetRowIdFunc>((params: GetRowIdParams) => {
return params.data.id;
});
const rowData = ref<any[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => {
// give each row an id
data.forEach(function (x: any, index: number) {
x.id = "R" + (index + 1);
});
const dataSource: IDatasource = {
rowCount: undefined, // behave as infinite scroll
getRows: (params: IGetRowsParams) => {
console.log(
"asking for " + params.startRow + " to " + params.endRow,
);
// At this point in your code, you would call the server
// To make the demo look real, wait for 500ms before returning
setTimeout(() => {
// take a slice of the total rows
const dataAfterSortingAndFiltering = sortAndFilter(
data,
params.sortModel,
params.filterModel,
);
const rowsThisPage = dataAfterSortingAndFiltering.slice(
params.startRow,
params.endRow,
);
// if on or after the last page, work out the last row.
let lastRow = -1;
if (dataAfterSortingAndFiltering.length <= params.endRow) {
lastRow = dataAfterSortingAndFiltering.length;
}
// call the success callback
params.successCallback(rowsThisPage, lastRow);
}, 500);
},
};
params.api!.setGridOption("datasource", dataSource);
};
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowModelType,
cacheOverflowSize,
maxConcurrentDatasourceRequests,
infiniteInitialRowCount,
maxBlocksInCache,
getRowId,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
export function countries() {
return [
'United States',
'Russia',
'Australia',
'Canada',
'Norway',
'China',
'Zimbabwe',
'Netherlands',
'South Korea',
'Croatia',
'France',
'Japan',
'Hungary',
'Germany',
'Poland',
'South Africa',
'Sweden',
'Ukraine',
'Italy',
'Czech Republic',
'Austria',
'Finland',
'Romania',
'Great Britain',
'Jamaica',
'Singapore',
'Belarus',
'Chile',
'Spain',
'Tunisia',
'Brazil',
'Slovakia',
'Costa Rica',
'Bulgaria',
'Switzerland',
'New Zealand',
'Estonia',
'Kenya',
'Ethiopia',
'Trinidad and Tobago',
'Turkey',
'Morocco',
'Bahamas',
'Slovenia',
'Armenia',
'Azerbaijan',
'India',
'Puerto Rico',
'Egypt',
'Kazakhstan',
'Iran',
'Georgia',
'Lithuania',
'Cuba',
'Colombia',
'Mongolia',
'Uzbekistan',
'North Korea',
'Tajikistan',
'Kyrgyzstan',
'Greece',
'Macedonia',
'Moldova',
'Chinese Taipei',
'Indonesia',
'Thailand',
'Vietnam',
'Latvia',
'Venezuela',
'Mexico',
'Nigeria',
'Qatar',
'Serbia',
'Serbia and Montenegro',
'Hong Kong',
'Denmark',
'Portugal',
'Argentina',
'Afghanistan',
'Gabon',
'Dominican Republic',
'Belgium',
'Kuwait',
'United Arab Emirates',
'Cyprus',
'Israel',
'Algeria',
'Montenegro',
'Iceland',
'Paraguay',
'Cameroon',
'Saudi Arabia',
'Ireland',
'Malaysia',
'Uruguay',
'Togo',
'Mauritius',
'Syria',
'Botswana',
'Guatemala',
'Bahrain',
'Grenada',
'Uganda',
'Sudan',
'Ecuador',
'Panama',
'Eritrea',
'Sri Lanka',
'Mozambique',
'Barbados',
];
}
Overlays Copy Link
The infinite row model does not automatically show the loading overlay as rows are loaded in blocks as the user interacts with the grid. The grid will show the no rows overlay if the datasource returns an empty array and the no matching rows overlay if an empty array is returned while filters are set.
For configuration details, including suppressing the built in overlays, see Overlays.